//<c>   Copyright 1993-1999 by Gerry J. Danen; all rights reserved.

//<t>   BBS login

#define IS_NETLOGIN
#include"nss.h"
#include"nss_mess.h"


GD_DEF  *formDat[3] ;
GD_DEH  formHdr ;

static  UCHAR   tempdir    []   ="c:\\system\\logger",  // priv: everyone R/W
                exepath    [256]="",
                datapath   [256]="",
                scriptfile [256]="",
                maildir    [256]="",
                tloginbat  [256]="",
                auditpwfile[256]="",
                mapins_path[FS_LEN]="" ;
static  UCHAR   lname[B_USERNAME_SIZE]="", lpass[48]="", cmd[256],
                serverName[SERVERNAME_SIZE]="", userName[B_USERNAME_SIZE],
                userFullname[128]="", loginDrive='H' ;
static  WORD    serverID, oldConnectionID ;
static  ULONG   userID ;
FILE    *tlbat ;
static  INT32   sys_ymd, sys_ymdn ;
static  int     nday_of_week, mapins_num = 1 ;
static  BOOL    log_password=FALSE, pw_has_expired=FALSE ;


#include"nss.ccc"
#include"netlrini.ccc"


BOOL    attempt_login(STRING nm,STRING pw,BOOL special);


void    output_password( int reason, STRING pw )
{
    strcpy( pw, "*" );
}


void    display_error_code( int code )
{
    printf( "Error %3d\n", code );
}


STRING  translate_code_to_msg( int code )
{
    static UCHAR m[25] ;
    int x ;

    LOOP( x, 0, (max_messages-1), 1 )
    {
        if ( code == netware_message[x].msgCode )
            return( netware_message[x].msgText );
    }
    sprintf( m, "Unknown message %04Xh", code );
    return ( m );
}


void    nw_msg_to_console( STRING msg, ... )
{
    UCHAR       nwbuf[161] ;
    va_list     arg_ptr ;

    va_start( arg_ptr, msg );
    vsprintf( nwbuf, msg, arg_ptr );
    va_end( arg_ptr );
    BroadcastToConsole( nwbuf );                // max 60 chars
}


void    log_major_problem( BOOL abort, int code, STRING msg, ... )
{
    UCHAR       mbuf[161], m_user[B_USERNAME_SIZE] ;
    va_list     arg_ptr ;
    FILE        *fh ;

    ST_CPY( m_user, userName );                 // save for later
    va_start( arg_ptr, msg );
    vsprintf( mbuf, msg, arg_ptr );
    va_end( arg_ptr );
    if ( attempt_login( bigbrother_id, bigbrother_pw, YES ) )
    {
        sprintf( cmd, "%s\\problems.dat", tempdir );
        fh = fopen( cmd, "a+" );
        if ( fh )
        {
            int skippy ;
            sprintf( cmd, "%s %8s %s", serverName, m_user, node_addr );
            skippy = 50 - strlen(cmd);
            if ( skippy < 1 )
                 skippy = 1 ;
            fprintf( fh, "%s %s problem report\n"
                         " [1] %s %s %s %*s %s\n"
                         " [2] %s\n"
                         " [3] 0x%02X (%d) %s\n\n",
                         get_global_program_name(), pgm_vers,
                         TodaysDay(), TodaysDate(), TodaysTime(), skippy, "", cmd,
                         mbuf, code, code, translate_code_to_msg( code ) );
            fclose( fh );
        }
        else
            nw_msg_to_console( "%s: Cannot log to %s", get_global_program_name(), cmd );
    }
    else
    {
//      fprintf( stderr, "\n\aCan't log at the moment.\a\nPlease report problems to your network administrator!\a\n" );
        nw_msg_to_console( "%s: Cannot login as %s", get_global_program_name(), bigbrother_id );
    }
    nw_msg_to_console( "%s: [%s] %s %s %s", get_global_program_name(), pgm_vers, TodaysDay(), TodaysDate(), TodaysTime() );
    nw_msg_to_console( "%s: %s %s %s", get_global_program_name(), serverName, m_user, node_addr );
    nw_msg_to_console( "%s: %s", get_global_program_name(), mbuf );
    nw_msg_to_console( "%s: 0x%02X (%d) %s", get_global_program_name(), code, code, translate_code_to_msg( code ) );

// quit:
    Logout();
    if ( abort )
        gd_exit( GD_ERROR_NW_NOT_LOGGED_IN, "" );
}


void    preprocess_script( void )
{
    FILE        *fh ;
    char        *p, buf[sizeof(cmd)], keyword[16] ;

    ST_CPY( tloginbat, nss.fiBatchfile );

    fh = fopen( scriptfile, "r" );
    if ( ! fh )
    {
        printf( "[PreProcess] Can't read script file: %s\n", scriptfile );
        return ;
    }

    while ( (p = fgets( cmd, sizeof(cmd)-1, fh )) )
    {
        StrDetab( (STRING)buf, (STRING)cmd, sizeof(cmd) );
        st_reduce_spaces( (STRING)buf );
        st_trim( (STRING)buf );
        keyword[0] = EOS ;
        if ( st_len_word( buf ) < 16L )         // keyword is max 15 chars
        {
            st_get_word( keyword, buf );        // get keyword
            st_remove_word( buf );              // remove keyword from string
        }
        if ( st_eq(keyword, "mapinsert") )
        {
            if ( st_len_word( buf ) < 16L )     // keyword is max 15 chars
            {
                st_get_word( keyword, buf );    // get keyword
                st_remove_word( buf );          // remove keyword from string
                mapins_num = atoi( keyword );
                ST_CPY ( mapins_path, buf );
                st_trim( mapins_path );
                strupr ( mapins_path );
            }
        }
        else
        if ( st_eq(keyword, "logger") )
        {
            if ( st_len_word( buf ) < 16L )     // keyword is max 15 chars
            {
                st_get_word( keyword, buf );    // get keyword
                if ( st_eq(keyword, "on") )
                    log_password = TRUE ;
            }
        }
        else
        if ( st_eq(keyword, "passverify") )
        {
            ST_CPY ( auditpwfile, buf );
            st_trim( auditpwfile );
            strupr ( auditpwfile );
        }
    }

    fclose( fh );

    if ( st_eq(tloginbat,"%gd.maildir%") )
        sprintf( tloginbat, "sys:mail\\%lX\\t$login.bat", userID );
}


void    get_next_word( UCHAR parm[], UCHAR buffer[], int szParm )
{
    parm[0] = EOS ;
    if ( st_len_word( buffer ) > (long) szParm )
        return ;
    st_get_word( parm, buffer );                // get parm
    st_remove_word( buffer );                   // remove parm from buffer
}


void    process_script_line( UCHAR l[] )
{
    static UCHAR keyword[16], p1[49], p2[49], p3[49] ;
    BOOL        member ;

    get_next_word( keyword, l, 15 );
    if ( ! strlen(keyword) )
        return ;
    get_next_word( p1, l, 48 );                 // get p1

    if ( st_eq(keyword, "cls") )
    {
        fprintf( tlbat, " cls\n" );
    }
    else
    if ( st_eq(keyword, "map") )
    {
        get_next_word( p2, l, 48 );
        if ( p2[1] == ':' )
            nw_map_fakeroot( p2[0], p1 );
        else
            fprintf( tlbat, " map root %s=%s >nul\n", p2, p1 );
    }
    else
    if ( st_eq(keyword, "set") )
    {
        fprintf( tlbat, " set %s=%s\n", p1, l );
    }
    else
    if ( st_eq(keyword, "memberyn") )
    {
        get_next_word( p2, l, 48 );
        strupr( p2 );
        member = nw_is_user_in_group( userName, p1 );
        fprintf( tlbat, " set %s=%s\n", p2, (member ? "Y" : "N") );
    }
    else
    if ( st_eq(keyword, "memberset") )
    {
        get_next_word( p2, l, 48 );
        get_next_word( p3, l, 48 );
        strupr( p2 );
        member = nw_is_user_in_group( userName, p1 );
        if ( member )
            fprintf( tlbat, " set %s=%s\n", p2, p3 );
    }
}


void    process_script( void )
{
    FILE        *fh ;
    char        *p, buf[sizeof(cmd)] ;

    fh = fopen( scriptfile, "r" );
    if ( ! fh )
    {
        printf( "[Process] Can't read script file: %s\n", scriptfile );
        return ;
    }
    fprintf( tlbat, "\nrem ---Script File %s---\nrem [%s %s %s]\n",
             scriptfile, nss.idScriptDate, nss.idScriptVers, nss.idPgmVers );

    while ( (p = fgets( cmd, sizeof(cmd)-1, fh )) )
    {
        StrDetab( (STRING)buf, (STRING)cmd, sizeof(cmd) );
        st_trim( (STRING)buf );
        if ( buf[0] == '@' )
        {
            buf[0] = ' ' ;
            st_trim( (STRING)buf );
            fprintf( tlbat, "%s%s\n", ((buf[0]==':' && buf[1]!=' ') ? "" : " "), buf );
        }
        else
        if ( buf[0] != ';' && buf[0] != '*' && buf[0] != EOS )
        {
            process_script_line( buf );
        }
    }
    fprintf( tlbat, "rem ---Script End---\n" );
    fclose( fh );
}


BOOL    attempt_login( STRING nm, STRING pw, BOOL special )
{
    int         verify ;

    strupr( nm );
    strupr( pw );
    strcpy( userName, nm );                     // in case we need to report it

//  attach to the file server that the user passed in
    verify = AttachToFileServer( serverName, &serverID );
    if ( (verify != 0) && (verify != ALREADY_ATTACHED_TO_SERVER) )
    {
        if ( special )
            return( FALSE );
        display_error_code( verify );
        if ( verify == ALREADY_ATTACHED_TO_SERVER )
            printf( "Already attached to server %s\n", serverName );
        else
        {
            printf( "Cannot locate server %s\n", serverName );
            printf( "%s\n", translate_code_to_msg(verify) );
        }
        output_password( verify, pw );
        log_major_problem( YES, verify, "Attach failed for %s:%s", nm, pw );
    }

//  Save original connection ID and set the preferred connection ID to be
//  that of the server just attached to
    oldConnectionID = GetPreferredConnectionID();
    SetPreferredConnectionID( serverID );
    pw_has_expired = FALSE ;
    verify = LoginToFileServer( nm, OT_USER, pw );
    if ( verify == PASSWORD_HAS_EXPIRED || verify == PASSWORD_HAS_EXPIRED_NO_GRACE )
    {
        pw_has_expired = TRUE ;
        verify = 0 ;
    }
    if ( verify )
    {
        if ( special )
        {
            return( FALSE );
        }
        else
        {
            display_error_code( verify );
            printf( "%s:%s\n", serverName, nm );
            printf( "Access to server denied\n" );
            printf( "%s\n", translate_code_to_msg(verify) );
            output_password( verify, pw );
            if ( strlen(nm) || strlen(pw) )
                log_major_problem( NO, verify, "Login failed for %s:%s", nm, pw );
//          HoldMsg( NO, YES );
            return( FALSE );
        }
    }

//  Now that we're logged in, get the user's object ID
    GetBinderyObjectID( nm, OT_USER, &userID );
    {
    BYTE moreSeg, propFlags ;
    verify = ReadPropertyValue( nm, OT_USER, "IDENTIFICATION", 1, userFullname, &moreSeg, &propFlags );
    if ( verify )
        userFullname[0] = EOS ;
    st_trim( userFullname );
    }
    nw_get_username( userName );
    SetPreferredConnectionID( serverID );
    return( TRUE );
}


BOOL    password_in_commonfile( STRING pw )
{
    FILE        *pf ;
    char        *p ;

    if ( ! strlen(auditpwfile) )
        return( FALSE );
    pf = fopen( (const char *) auditpwfile, "r" );
    if ( pf == NULL )
        return( FALSE );

    while ( (p = fgets( cmd, sizeof(cmd)-2, pf )) )
    {
        st_trim( cmd );
        if ( st_eq(cmd, pw) )
        {
            fclose( pf );
            return( TRUE );
        }
    }
    fclose( pf );
    return( FALSE );
}


BOOL    password_character_check_failure( UCHAR pw[] )
{
    register int i ;
    int a=0, imax=strlen(pw)-1;

    LOOP( i, 0, imax, 1 )
    {
        if ( isspace(pw[i]) )
            return( TRUE );
        if ( ! isalpha(pw[i]) )
            a += 1 ;
    }
    if ( a == 0 )
        return( TRUE ); // no non-alpha chars
    return( FALSE );    // not failed
}


void    find_windows_directory( UCHAR winhome[] )
{
    UCHAR       wdir[256], test[256], wpath[256] ;

    winhome[0] = EOS ;
    ST_CPY( test, wPath );
    do  {
        st_get_word( wdir, test );              // get possible path
        st_remove_word( test );                 // remove from string
        sprintf( wpath, "%s\\%s", wdir, wProg );
        if ( fl_exist( wpath ) )
        {
            strcpy( winhome, wdir );
            test[0] = EOS ;
        }
    }   while( strlen(test) );
}


void    main_exit( void )
{
    if ( finish_off_code == BAD_EXIT )
        fprintf( stderr, "Aborting program %s", get_global_program_name() );
    fcloseall();
    CursOn();
}


//~~~
int     locate_file( STRING sTarget, STRING sFile, STRING sExt )
{
//  location of files...
//      if filename is qualified, use it
//      else look on "datapath"
//      else look in directory where .exe was loaded

    sprintf( sTarget, "%s%s", sFile, sExt );
    if ( fl_exist( sTarget ) )
        return( OK );
    sprintf( sTarget, "%s\\%s%s", datapath, sFile, sExt );
    if ( fl_exist( sTarget ) )
        return( OK );
    sprintf( sTarget, "%s\\%s%s", exepath, sFile, sExt );
    if ( fl_exist( sTarget ) )
        return( OK );
    log_major_problem( YES, 0xFF, "Could not locate %s%s", sFile, sExt );
    return( ERROR );
}


void    main( int argc, char *argv[] )
{
    unsigned    numofdrives ;
    int         ccode, bottom_offset=0 ;
    ULONG       oID ;
    UCHAR       *ptr ;
    BOOL        good_login ;

    fs_init( FALSE, SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );
//  Allow_No_Break();                           // allow no ^Break to abort
    atexit( main_exit );
    printf( "\nBBS login\n%s\n\n", pgm_copyrite );
    read_login_set();                           // get "big brother" info
    {
    INT16       d, m, y ;
    dt_getsystemdate( &sys_ymd, &y, &m, &d );
    sys_ymdn = Date2Num( sys_ymd );
    nday_of_week = dt_dow( d, m, y );
    }
    RandomSeed();                               // re-seed random number generator
                                                // used by sayings, screen blanker
    if ( ! nw_installed_NetWare() )
        abort_job( 1, "Not logged in to a NetWare file server!" );

    ST_CPY( exepath, argv[0] );                 // location of .exe file
    ptr = strrchr( exepath, '\\' );
    *ptr = EOS ;

    locate_file( iniFile    , "netlogin", ".ini" );
    load_nss_ini();
    locate_file( scriptfile , "netlogin", ".scr" );

    GetFileServerName( (WORD) 0, serverName );
    nw_get_station_address( node_addr );

    loginDrive= *argv[0] ;                      // from location of .exe file
    *tempdir  = loginDrive ;
    _dos_setdrive( loginDrive - (int)'@', &numofdrives );

    nw_get_username( userName );
    if ( strlen(userName) )
    {
        printf( "Already logged in as %s.  Logging out first!\n", userName );
        Logout();
    }

    strcpy( lname, "BBS" );
    strcpy( lpass, "efqp8652RRtg11lal" );

    preprocess_script();

    good_login = attempt_login( lname, lpass, NO );
    if ( ! good_login )
        gd_exit( GD_ERROR_NW_NOT_LOGGED_IN, "" );

//  login was successful, now the fun begins...
    printf( "Logged in %s:%s on node %s\n", serverName, userName, node_addr );
    printf( "Troubleshooting Info: %s %s %s\n",
             nss.idScriptDate, nss.idScriptVers, nss.idPgmVers );

    ccode = get_login_control( userName, OT_USER, &oID, propValue, &lt );
    cmd[0] = EOS ;
    lname[8] = EOS ;

//~~~
//  try to create directory first, in which to write `tloginbat'
//~~~

    tlbat = fopen( tloginbat, "w" );
    if ( ! tlbat )
        abort_job( 1, "Can't create batch file %s", tloginbat );

    StrR( cmd, node_addr, 8 );
    fprintf( tlbat, "@echo off\n"
                    " set gd.logdate=%s %s %s\n"
                    " set gd.maildir=%lX\n"
                    " set svr=%s\n"
                    " set usr=%s\n"
                    " set usr_init=%s\n"
                    " set stn=%s\n"
                    " set stn8=%s\n",
                    TodaysDay(), TodaysDate(), TodaysTime(),
                    userID, serverName, lname, userFullname,
                    node_addr, cmd );

    find_windows_directory( cmd );
    fprintf( tlbat, " set win.home=%s\n", cmd );
    fprintf( tlbat, " set gd.dow=%d\n", nday_of_week );

    st_get_env_var( mapins_path, cmd, sizeof(cmd), "c:\\dos;", YES );

    if ( strlen(cmd) )
    {
        int i ;
        fprintf( tlbat, " set path=" );
        LOOP( i, 1, mapins_num, 1 )
        {
            fprintf( tlbat, "c:\\;" );
        }
        fprintf( tlbat, "%s\n", cmd );
    }
    else
    {
        printf( "Environment variable [%s] not found\n", mapins_path );
    }

    process_script();

    fclose( tlbat );

    happy_ending();
}
