//<c>   Copyright 1993-1999 by Gerry J. Danen; all rights reserved.

//<t>   NetWare Disk Usage Analysis

#define IS_DUSAGE
#include"nss.h"

//      /C & /A combo:
//      "groupname","usedbygroup","#members"
//      "DANENS",1193616,5

#define REGISTERED_VERSION 1
#if     REGISTERED_VERSION
static  STRING  rv_ident_[] =
{
//                      "In-Flight Phone Corporation",
//                      "Oakbrook Terrace, IL, U.S.A.",
//                      "1 license: " pgVERS__ ,
//                      "BCS Information Technology Solutions",
//                      "Brisbane, Australia",
//                      "4 licenses: " pgVERS__ ,
//                      "Davy International",
//                      "Sheffield   S9 4EX",
//                      "England",
//                      "1 license: " pgVERS__ ,
//                      "SWL Inc.",
//                      "1900 Gallows Road",
//                      "Vienna, Virginia 22182",
//                      "U.S.A.",
//                      "1 server license: " pgVERS__ ,
//                      "Dakota Electric Association",
//                      "Farmington, Minnisota, USA",
//                      "1 server license: " pgVERS__ ,
//                      "Northlands Park",
//                      "Edmonton, AB, Canada",
//                      "1 license: " pgVERS__ ,
                        "Public Release",
                        ""
};
#endif

#define TRIAL_VERSION 0
#if     TRIAL_VERSION
static  STRING  tv_ident_[] =
                {
                        "Amoco Production Company",
                        "Fort Lupton Operations Center",
                        "Wattenberg Gas Plant",
                        "Aurora, Colorado, U.S.A.",
                        "Mike Campbell",
                        "Trial expires April 15th, 1995",
                        ""
                };
#endif


static  NWVOL_USAGE vu ;
static  t_volume_info vi[32] ;
static  WORD    defaultConnID, primaryConnID, preferredConnID, serverConnID,
                maxVolume ;
static  UCHAR   serverName[SERVERNAME_SIZE]="",
                userAsksForServer[SERVERNAME_SIZE]="",
                userName[B_USERNAME_SIZE]="",
                groupName[B_USERNAME_SIZE]="" ;
static  char    buf[BUFSIZE], sVolName[65] ;
static  char    *groups[MAXUSER+1], *users[MAXUSER+1] ;
static  ULONG   uID[MAXUSER+1] ;
static  int     grp_end=0, total_groups=0, this_grp=0 ;
static  int     user_end=0, total_users=0, this_user=0, max_username=8, max_volname=10 ;
static  FILE    *rf ;
static  UCHAR   outputFile[256]="" ;
static  BOOL    ynAnalysis=FALSE, ynComma=FALSE, ynDebug=FALSE,
                ynGotParms=FALSE, ynGroup=FALSE, ynRestrictions=FALSE,
                ynSetConnections=FALSE, ynShowAll=TRUE, ynSize=FALSE,
                ynVerbose=FALSE, ynVolume=FALSE ;
static  ULONG   nKbUsed, nKbRestr, nKbFree, nSize ;
static  UCHAR   sKbytes[65] ;


#include"nss.ccc"


void    add_user(void);
void    check_volume(void);
void    do_help(void);
void    do_parm(STRING par);
void    group_analysis(void);
void    init_volume_info(void);
void    load_grouplist(void);
void    load_userlist(void);
void    load_user_objIDs(void);
void    main_exit(void);
void    main_init(int argc,char *argv[]);
void    process_group(STRING gN,WORD objectType);
void    process_user(STRING uN,WORD objectType);
int     qs_compare(const char **arg1,const char **arg2);
void    report_headings(void);
void    show_options(void);


void    main( int argc, char *argv[] )
{
    main_init( argc, argv );

    init_volume_info();
    load_userlist();
    load_grouplist();

    if ( ynAnalysis )
    {
        group_analysis();
    }
    else
    {
        sc_progress_init( "User Analysis of Server %s", serverName );
        if ( ynComma )
            check_volume();
        else
            report_headings();
        for ( this_user=0 ; this_user<user_end ; this_user++ )
        {
            sc_progress( (this_user*100) / user_end );
            process_user( users[this_user], OT_USER );
        }
        sc_progress_exit( 3 );                  // clear progress box
    }

    ClearEOS();
    printf( "\n\nThe information is in %s.\n", outputFile );

#if TRIAL_VERSION
    {
    int tv=0 ;
    fprintf( stderr, "\nTrial version for:\n" );
    while ( strlen(tv_ident_[tv]) )
    {
        fprintf( stderr, "\t%s\n", tv_ident_[tv] );
        tv++ ;
    }
    fprintf( stderr, "\n" );
    }
#endif

#if REGISTERED_VERSION
    {
    int rv=0 ;
    fprintf( stderr, "\nRegistered to:\n" );
    while ( strlen(rv_ident_[rv]) )
    {
        fprintf( stderr, "\t%s\n", rv_ident_[rv] );
        rv++ ;
    }
    fprintf( stderr, "\n\tPlease do NOT distribute registered software.\n" );
    }
#endif

    happy_ending();
}


void    main_init( int argc, char *argv[] )
{
    UCHAR       parm[256] ;
    int         i ;

    fs_init( FALSE, SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );
    atexit( main_exit );
    NewScreen();

    if ( ! nw_installed_NetWare() )
    {
        ErrMsg( "NetWare is not available" );
        gd_exit( BAD_EXIT, "" );
    }

    defaultConnID   = GetDefaultConnectionID();
    primaryConnID   = GetPrimaryConnectionID();
    preferredConnID = GetPreferredConnectionID();
    ynSetConnections = TRUE ;

    GetFileServerName( (WORD) 0, serverName );
    GetConnectionID( serverName, &serverConnID );

    argc -= 1 ;
    LOOP( i, 1, argc, 1 )                       // check parameters
    {
        ST_CPY( parm, argv[i] );
        if ( parm[0] == '/' || parm[0] == '-' )
            do_parm( &parm[1] );
    }

    if ( ynComma )
        sprintf( outputFile, "%s.%s", get_global_program_name(), "CSV" );
    else
        sprintf( outputFile, "%s.%s", get_global_program_name(), "REP" );

    rf = fopen( outputFile, "w" );
    if ( ! rf )
    {
        ErrMsg( "Could not open file %s for output", outputFile );
        gd_exit( BAD_EXIT, "" );
    }

    if ( ynDebug )
    {
        int x ;
        fprintf( rf, "*debug* connection info:\n"
                     "\tdefault  = %u\n\tprimary  = %u\n\tpreferred= %u\n",
                     defaultConnID, primaryConnID, preferredConnID );
        LOOP( x, 1, 8, 1 )
        {
            fprintf( rf, "\tserver %d = %s\n", x, nw_server_name( (WORD16) x ) );
        }
    }

#if REGISTERED_VERSION
    if ( strlen(userAsksForServer) )
    {
        int what ;
        strcpy( serverName, userAsksForServer );
        what = GetConnectionID( serverName, &serverConnID );
        if ( ynDebug )
            fprintf( rf, "*debug* server info: %s [%u] return code=%d\n",
                         serverName, serverConnID, what );
        if ( what == 0 || what == 0xF8 )
        {
            SetPrimaryConnectionID  ( primaryConnID   );
            SetPreferredConnectionID( preferredConnID );
        }
        else
        {
            ErrMsg( "Could not find server %s", serverName );
            gd_exit( BAD_EXIT, "" );
        }
    }
#else
    if ( strlen(userAsksForServer) )
    {
        ErrMsg( "The SERVER option is available in the registered version only." );
        gd_exit( BAD_EXIT, "" );
    }
#endif

    if ( ynVolume && ynRestrictions )           // can't do both
        ynRestrictions = FALSE ;

    if ( ynGotParms )
        show_options();
    else
        printf( "\nUse %s /? to see reporting options.\n\n", get_global_program_name() );

    WaitMsg();
}


void    main_exit( void )
{
#if ! REGISTERED_VERSION
    st_shareware( "$25 per user, or $100 per server" );
#endif
    fcloseall();
    CursOn();
    if ( ynSetConnections )
    {
        SetPrimaryConnectionID  ( primaryConnID   );
        SetPreferredConnectionID( preferredConnID );
    }
}


void    do_help( void )
{
    printf( "Options:"
            "\n\t/a          : analyze disk usage by group"
            "\n\t/c          : produce a comma-delimited file (.csv) for Excel, etc."
            "\n\t/g=xxx      : report only on members of group \"xxx\""
            "\n\t/r          : show restrictions only"
            "\n\t/s=nnn      : report only sizes of \"nnn\" Kbytes or more"
            "\n\t/server=xxx : report on server xxx"
            "\n\t/v=xxx      : report details on volume \"xxx\""
            "\n\t/x          : extra info for group analysis (verbose mode)"
            "\n\t/debug      : show debug info"
            "\n\n" );
    happy_ending();
}


void    show_options( void )
{
    printf( "\nOptions:"
                "\tAnalyze group usage .............. %s"
            "\n\t\tOutput to Comma-delimited file ... %s"
            "\n\t\tSpecified Group .................. %s"
            "\n\t\tShow Restrictions ................ %s"
            "\n\t\tSize Limitations ................. %s"
            "\n\t\tSingle Volume .................... %s"
            "\n\t\tDebug Information ................ %s\n",
            st_YESNO(ynAnalysis),
            st_YESNO(ynComma),
            st_YESNO(ynGroup),
            st_YESNO(ynRestrictions),
            st_YESNO(ynSize),
            st_YESNO(ynVolume),
            st_YESNO(ynDebug) );
}


void    do_parm( STRING par )
{
    UCHAR       p ;

    _strupr( par );
    p = *par++ ;
    ynGotParms = TRUE ;
    switch ( p )
    {
        case 'A' :                              // group analysis
            ynAnalysis = TRUE ;
            break ;
        case 'C' :                              // output to comma-delimited file
            ynComma = TRUE ;
            break ;
        case 'D' :                              // debug mode?
            if ( st_eq(par, "ebug") )
                ynDebug = TRUE ;
            break ;
        case 'G' :                              // check only this group
            if ( *par == '=' )
            {
                par++ ;
                if ( strlen(par) )
                {
                    ST_CPY ( groupName, par );
                    st_trim( groupName );
                    strupr ( groupName );
                    ynGroup = TRUE ;
                }
            }
            break ;
        case 'R' :                              // show volume restrictions
            ynRestrictions = TRUE ;
            break ;
        case 'S' :                              // check only users with size
            if ( *par == '=' )
            {
                par++ ;
                if ( strlen(par) )
                {
                    nSize = (ULONG) Str2Long( par );
                    ynSize = TRUE ;
                }
            }
            else
            {
                UCHAR s[7] ;
                int i ;
                ST_CPY( s, par );
                if ( st_eq(s, "erver=") )
                {
                    LOOP(i,1,6,1)
                        par ++ ;
                    st_cpy( userAsksForServer, par, SERVERNAME_SIZE );
                }
            }
            break ;
        case 'V' :                              // check only this volume
            if ( *par == '=' )
            {
                par++ ;
                if ( strlen(par) )
                {
                    ST_CPY ( sVolName, par );
                    st_trim( sVolName );
                    ynVolume = TRUE ;
                    ynShowAll = FALSE ;
                }
            }
            break ;
        case 'X' :                              // verbose analysis
            ynVerbose = TRUE ;
            break ;
        case '?' :                              // help
        case 'H' :
            do_help();
        default  :
            fprintf( stderr, "\nSwitch \"%c\" is not legal.\a\n", p );
            do_help();
    }
}


void    check_volume( void )
{
    int         x, vfound = -1 ;

    if ( ynShowAll )
        return ;

    LOOP( x, 0, (int) maxVolume, 1 )
    {
        if ( st_eq( sVolName, vi[x].volName ) )
            vfound = x ;
    }
    if ( vfound == -1 )
    {
        sprintf( buf, "Volume %s does not exist on server %s", sVolName, serverName );
        fprintf( rf, "\n%s\n", buf );
        ErrMsg( "%s", buf );
        gd_exit( BAD_EXIT, "" );
    }

    // transfer to first position and set maxVolume to 0
    free( vi[0].volName );
    vi[0].volName      = strdup( vi[vfound].volName );
    vi[0].volNumber    = vi[vfound].volNumber    ;
    vi[0].volBlockSize = vi[vfound].volBlockSize ;
    vi[0].volBlocks    = vi[vfound].volBlocks    ;
    maxVolume = 0 ;
}


void    rep_hdg_start( void )
{
    fprintf( rf, "%s [%s %s %s]\n%s\n\n", pgm_title, pgm_name, pgm_vers,
                 REGISTERED_VERSION ? "Registered" : "ShareWare", pgm_copyrite );

#if REGISTERED_VERSION
    {
    int rv=0 ;
    fprintf( rf, "Registered to:\n" );
    while ( strlen(rv_ident_[rv]) )
    {
        fprintf( rf, "\t%s\n", rv_ident_[rv] );
        rv++ ;
    }
    fprintf( rf, "\n" );
    }
#else
    fprintf( rf, "Please register this ShareWare program.\n\n" );
#endif
}


void    report_headings( void )
{
    int         x ;

    rep_hdg_start();
    fprintf( rf, " Server %s has %d volume%s:\n", serverName, (int) maxVolume+1, ((maxVolume+1)==1) ? "" : "s" );
    LOOP( x, 0, (int) maxVolume, 1 )
    {
        nKbUsed = vi[x].volBlocks * vi[x].volBlockSize ;
        Format_UINT32( nKbUsed, sKbytes );
        fprintf( rf, "\t%-*s%10s Kbytes\n", max_volname, vi[x].volName, sKbytes );
    }
    fprintf( rf, "\n\n" );
    if ( ynGroup )
        fprintf( rf, "Processing only members of the %s group.\n\n", groupName );

    if ( ynShowAll )
    {
        if ( ynRestrictions )
            fprintf( rf, "Quantities shown under volumes are Volume Restrictions!\n\n" );
        if ( ynSize )
            fprintf( rf, "Showing only users with %ld Kbytes or more across all volumes.\n\n", nSize );
        fprintf( rf, "%-*s %*s", max_username, "User", max_volname, "Total Used" );
        LOOP( x, 0, (int) maxVolume, 1 )
        {
            fprintf( rf, "%*s", max_volname, vi[x].volName );
        }
        StrFill( sKbytes, (UCHAR)'', max_username+1 );
        fprintf( rf, "\n%s ", sKbytes );
        StrFill( sKbytes, (UCHAR)'', max_volname+1 );
        fprintf( rf, "%s", sKbytes );
        LOOP( x, 0, (int) maxVolume, 1 )
        {
            StrFill( sKbytes, (UCHAR)'', max_volname );
            fprintf( rf, " %s", sKbytes );
        }
        fprintf( rf, "\n" );
    }
    else
    {
        check_volume();

        if ( ynSize )
            fprintf( rf, "Showing only users with %ld Kbytes or more on this volume.\n\n", nSize );
        fprintf( rf, "Usage of Volume %s:\n\n", sVolName );
        fprintf( rf, "%-*s %*s %*s %*s    %%\n",
                     max_username, "User", max_volname, "Used",
                     max_volname, "Restricted", max_volname, "Free" );
        StrFill( sKbytes, (UCHAR)'', max_username+1 );
        fprintf( rf, "%s ", sKbytes );
        StrFill( sKbytes, (UCHAR)'', max_volname+1 );
        fprintf( rf, "%s %s %s \n", sKbytes, sKbytes, sKbytes );
    }
}


void    init_volume_info( void )
{
    int         x ;
    WORD        ccode ;

    if ( ynDebug )
        fprintf( rf, "*debug* volume info:\n" );

    LOOP( x, 0, 31, 1 )
    {
        vi[x].volName = NULPTR ;
        vi[x].volNumber = 0 ;
        vi[x].volBlockSize = 0 ;
        ccode = GetVolUsage( serverConnID, (WORD) x, &vu );
        if ( ! ccode )
        {
            if ( ! st_eq(vu.volName," ") )
            {
                vi[x].volName = strdup( vu.volName );
                vi[x].volNumber = x ;
                vi[x].volBlockSize = (int) (vu.blockSize / SZ_kBYTE);
                vi[x].volBlocks = vu.totalBlocks ;
                maxVolume = x ;
                if ( (int) strlen(vi[x].volName) > max_volname )
                    max_volname = strlen(vi[x].volName);
                if ( ynDebug )
                    fprintf( rf, "*debug* volname %s, # %d, blksiz %d, %lu blocks\n",
                             vi[x].volName, vi[x].volNumber, vi[x].volBlockSize, vi[x].volBlocks );
            }
        }
    }
    max_volname += 1 ;
}


void    load_userlist( void )
{
    int         ret ;
    char        objectName[B_USERNAME_SIZE], objectNameToSearch[B_USERNAME_SIZE] ;
    long        objectID ;
    WORD        objectType, objectTypeToSearch ;
    BYTE        objectHasProperties, objectFlag, objectSecurity ;

    user_end = 0 ;

    if ( ynDebug )
        fprintf( rf, "*debug* loading userlist\n" );

    for ( objectID = OT_WILD, ret = 0 ; (! ret) ; )     // check all users
    {
        strcpy( objectNameToSearch, "*" );
        objectTypeToSearch = OT_USER ;
        ret = ScanBinderyObject( objectNameToSearch, objectTypeToSearch,
                                 &objectID, objectName, &objectType,
                                 &objectHasProperties, &objectFlag,
                                 &objectSecurity );
        if ( ! ret )
        {
            strcpy( buf, objectName );
            st_reduce_spaces( (STRING)buf );
            st_trim( (STRING)buf );
            _strupr( buf );
            if ( ynGroup )
            {
                if ( nw_is_user_in_group(buf, groupName) )
                    add_user();
            }
            else
                add_user();
        }
    }
    qsort( (char *)users, (size_t)user_end, (size_t)sizeof(char *), qs_compare );
    load_user_objIDs();

    if ( ynDebug )
        fprintf( rf, "*debug* %d entries in userlist\n", user_end );
}


void    add_user( void )
{
    if ( user_end < MAXUSER )
    {
        if ( strlen(buf) )
        {
            users[user_end] = _strdup(buf);
            if ( users[user_end] == NULL )
            {
                ErrMsg( "Out of memory" );
                gd_exit( BAD_EXIT, "" );
            }
            user_end += 1 ;
            if ( (int) strlen(buf) > max_username )
                max_username = strlen(buf);
        }
    }
    else
    {
        printf( "\nToo many entries in the user list: %s\n", buf );
    }
}


void    load_grouplist( void )
{
    int         ret ;
    char        objectName[B_USERNAME_SIZE], objectNameToSearch[B_USERNAME_SIZE] ;
    long        objectID ;
    WORD        objectType, objectTypeToSearch ;
    BYTE        objectHasProperties, objectFlag, objectSecurity ;

    grp_end = 0 ;

    if ( ynDebug )
        fprintf( rf, "*debug* loading grouplist\n" );

    for ( objectID = OT_WILD, ret = 0 ; (! ret) ; )     // check all groups
    {
        strcpy( objectNameToSearch, "*" );
        objectTypeToSearch = OT_USER_GROUP ;
        ret = ScanBinderyObject( objectNameToSearch, objectTypeToSearch,
                                 &objectID, objectName, &objectType,
                                 &objectHasProperties, &objectFlag,
                                 &objectSecurity );
        if ( ! ret )
        {
            strcpy( buf, objectName );
            st_reduce_spaces( (STRING)buf );
            st_trim( (STRING)buf );
            _strupr( buf );
            if ( grp_end < MAXUSER )
            {
                if ( strlen(buf) )
                {
                    groups[grp_end] = _strdup(buf);
                    if ( groups[grp_end] == NULL )
                    {
                        ErrMsg( "Out of memory" );
                        gd_exit( BAD_EXIT, "" );
                    }
                    grp_end += 1 ;
                }
            }
            else
            {
                printf( "\nToo many entries in the group list: %s\n", buf );
            }
        }
    }
    qsort( (char *)groups, (size_t)grp_end, (size_t)sizeof(char *), qs_compare );

    if ( ynDebug )
        fprintf( rf, "*debug* %d entries in grouplist\n", grp_end );
}


int     qs_compare( const char **arg1, const char **arg2 )
{
    return( _stricmp( *arg1, *arg2 ) );
}


void    load_user_objIDs( void )
{
    ULONG       oID ;

    for ( this_user=0 ; this_user<user_end ; this_user++ )
    {
        get_login_control( users[this_user], OT_USER, &oID, propValue, &lt );
        uID[this_user] = oID ;
    }
}


void    process_user( STRING uN, WORD objectType )
{
    int         x ;
    ULONG       oID, volRestriction, volInUse, totalInUse, pct_free ;
    BOOL        isRestr ;

    StatusMsg( "User %s", uN );

    oID = uID[this_user] ;
    totalInUse = 0 ;
    LOOP( x, 0, (int) maxVolume, 1 )            // collect total used
    {
        nw_get_obj_restrictions( serverConnID, (BYTE) vi[x].volNumber, oID, &volRestriction, &volInUse, &isRestr );

        if ( ynDebug )
            fprintf( rf, "*debug* user %s, ID # %08lX, BS=%d, %lu in use, %lu restr %s\n",
                     uN, oID, vi[x].volBlockSize, volInUse, volRestriction,
                     (isRestr ? "[RES.SET]" : "") );

        volInUse = volInUse * 4 ;
        totalInUse += volInUse ;
    }

//  If SIZE report, weed out those with size lt nSize
//  Does not apply to restrictions report

    if ( ! ynRestrictions )
    {
        if ( ynShowAll )
        {
            if ( totalInUse < nSize )
                return ;
        }
        else                                    // just one volume
        {
            x = 0 ;
            nw_get_obj_restrictions( serverConnID, (BYTE) vi[x].volNumber, oID, &volRestriction, &volInUse, &isRestr );
            nKbUsed = volInUse * 4 ;
            if ( nKbUsed < nSize )
                return ;
        }
    }

    if ( ynComma )
        fprintf( rf, "\"%s\"", uN );
    else
        fprintf( rf, "%-*s ", max_username, uN );

    if ( ynShowAll )
    {
        Format_UINT32( totalInUse, sKbytes );
        if ( ynComma )
            fprintf( rf, ",%ld", totalInUse );
        else
            fprintf( rf, "%*s", max_volname, sKbytes );
        LOOP( x, 0, (int) maxVolume, 1 )
        {
            nw_get_obj_restrictions( serverConnID, (BYTE) vi[x].volNumber, oID, &volRestriction, &volInUse, &isRestr );
            if ( ynRestrictions )
                nKbUsed = volRestriction * 4 ;
            else
                nKbUsed = volInUse * 4 ;
            Format_UINT32( nKbUsed, sKbytes );
            if ( ynRestrictions )
            {
                if ( ! isRestr )
                    strcpy( sKbytes, "" );
            }
            if ( ynComma )
            {
                if ( ynRestrictions )
                {
                    if ( ! isRestr )
                        fprintf( rf, "," );
                    else
                        fprintf( rf, ",%ld", nKbUsed );
                }
                else
                    fprintf( rf, ",%ld", nKbUsed );
            }
            else
                fprintf( rf, "%*s", max_volname, sKbytes );
        }
    }
    else
    {
        x = 0 ;                                 // first bucket for single volume
        nw_get_obj_restrictions( serverConnID, (BYTE) vi[x].volNumber, oID, &volRestriction, &volInUse, &isRestr );
        nKbUsed = volInUse * 4 ;
        Format_UINT32( nKbUsed, sKbytes );
        if ( ynComma )
            fprintf( rf, ",%ld", nKbUsed );
        else
            fprintf( rf, "%*s ", max_volname, sKbytes );
        nKbUsed = volRestriction * 4 ;
        if ( ynComma )
        {
            if ( isRestr )
            {
                fprintf( rf, ",%ld", nKbUsed );
                nKbFree = (volRestriction - volInUse) * 4 ;
                fprintf( rf, ",%ld", nKbFree );
            }
            else
            {
                fprintf( rf, ",," );
            }
        }
        else
        {
            Format_UINT32( nKbUsed, sKbytes );
            if ( ! isRestr )
                strcpy( sKbytes, "" );
            fprintf( rf, "%*s ", max_volname, sKbytes );
            if ( isRestr )
            {
                nKbFree = volRestriction - volInUse ;
                nKbUsed = nKbFree * 4 ;
                if ( volInUse > volRestriction )
                    strcpy( sKbytes, "****" );
                else
                    Format_UINT32( nKbUsed, sKbytes );
                fprintf( rf, "%*s", max_volname, sKbytes );
                if ( volInUse <= volRestriction )
                {
                    if ( volRestriction == 0 )
                    {
                        pct_free = 0 ;
                    }
                    else
                    {
                        pct_free = ( nKbFree * 1000L / volRestriction) + 5 ;
                        pct_free = pct_free / 10L ;
                    }
                    fprintf( rf, " %3d%%", (int) pct_free );
                    if ( (pct_free < 5) || (nKbUsed < (ULONG)SZ_kBYTE) )
                    {
                        if ( ! ((volInUse == volRestriction) && volInUse == 0) )
                            fprintf( rf, " <** low **>" );
                    }
                }
            }
        }
    }
    fprintf( rf, "\n" );
}


void    group_analysis( void )
{
#if !   REGISTERED_VERSION
    fprintf( rf, "AVAILABLE ONLY IN THE REGISTERED VERSION!\n\n"
                 "Registered users may request program enhancements.\n\n" );
    return ;
#endif

    if ( ! ynComma )
    {
        rep_hdg_start();
        fprintf( rf, "Group Analysis: %s %s %s\n\n\n", TodaysDay(), TodaysDate(), TodaysTime() );
    }

//  If /G was specified, only that group's members will be processed.

    sc_progress_init( "Group Analysis" );
    for ( this_grp=0 ; this_grp<grp_end ; this_grp++ )
    {
        sc_progress( (this_grp*100) / grp_end );
        process_group( groups[this_grp], OT_USER_GROUP );
    }
    sc_progress_exit( 3 );                      // clear progress box
}


void    process_group( STRING gN, WORD objectType )
{
    int         m, n, x, usersInGroup=0 ;
    ULONG       oID, volRestriction, volInUse, totalInUse, gInUse=0, largestInUse=0 ;
    STRING      uN, largestUser ;

    StatusMsg( "Group %s", gN );

    for ( this_user=0 ; this_user<user_end ; this_user++ )
    {
        uN = users[this_user] ;
        oID = uID[this_user] ;
        if ( nw_is_user_in_group( uN, gN ) )
        {
            usersInGroup += 1 ;
            totalInUse = 0 ;
            LOOP( x, 0, (int) maxVolume, 1 )            // collect total used
            {
                GetObjectDiskRestrictions( serverConnID, (BYTE) x, oID, &volRestriction, &volInUse );
                totalInUse = totalInUse + (volInUse * 4);
            }
            gInUse += totalInUse ;
            if ( totalInUse > largestInUse )
            {
                largestInUse = totalInUse ;
                largestUser  = users[this_user] ;
            }
        }
    }

    if ( usersInGroup )
    {
        if ( ynComma )
        {
            fprintf( rf, "\"%s\",%ld,%d\n", gN, gInUse, usersInGroup );
        }
        else
        {
            Format_UINT32( gInUse, sKbytes );
            fprintf( rf, "%s has %d ", gN, usersInGroup );
            if ( ynGroup )
            {
                if ( ! st_eq(gN,groupName) )
                    fprintf( rf, "%s ", groupName );
            }
            fprintf( rf, "member%s using %s Kb\n", (usersInGroup==1 ? "" : "s"), sKbytes );

            if ( gInUse != 0 && largestInUse != 0 )
            {
                Format_UINT32( largestInUse, sKbytes );
                fprintf( rf, "\t%s is the primary user with %s Kb\n", largestUser, sKbytes );
            }

            if ( (ynGroup && st_eq(gN,groupName)) || ynVerbose )
            {
                fprintf( rf, "\tMembers of this group:\n\t" );
                n = 0 ;
                m = 71 / (max_username+1) ;
                for ( this_user=0 ; this_user<user_end ; this_user++ )
                {
                    uN = users[this_user] ;
                    oID = uID[this_user] ;
                    if ( nw_is_user_in_group( uN, gN ) )
                    {
                        fprintf( rf, "%-*s ", max_username, uN );
                        n += 1 ;
                        if ( n >= m )
                        {
                            fprintf( rf, "\n\t" );
                            n = 0 ;
                        }
                    }
                }
                if ( n )
                    fprintf( rf, "\n" );
            }
            fprintf( rf, "\n" );
        }
    }
    else
    {
        if ( ynComma )
        {
            fprintf( rf, "\"%s\",0,0\n", gN );
        }
        else
        {
            if ( ! ynGroup )
                fprintf( rf, "%s has no members\n\n", gN );
        }
    }
}
