//<c>   Copyright 1993-1999 by Gerry J. Danen; all rights reserved.

//<t>   EQTRACK conversion

#define IS_EQTRACK
#include"nss.h"


static  char    buf[BUFSIZE], buf1[BUFSIZE], keyword[16] ;
static  UCHAR   serverName[SERVERNAME_SIZE]="", userName[B_USERNAME_SIZE]="", nodeAddr[13]="",
                eqDir[] = "C:\\NET\\MACHINE", eqFile[] = "Inv", eqSpec[sizeof(eqDir)+sizeof(eqFile)] ;
static  UCHAR   logfile[256] = "" ;
static  UCHAR   cpuSer[31]="", cpuInv[11]="", kbSer[31]="", kbInv[11]="", monSer[31]="", monInv[11]="",
                nicID[31]="", nicType[31]="", wsIdent[41]="", defUser[9]="" ;
static  BOOL    batch_mode = FALSE, write_mode = FALSE ;
static  ULONG   userID = 0 ;


#define FORM1_FIELDS    9
GD_DEF  *form1[FORM1_FIELDS] ;
GD_DEH  fhdr1 ;


#include"nss.ccc"


void    read_eq_data( void )
{
    FILE        *fh ;
    UCHAR       *p ;

    fh = fopen( eqSpec, "r" );
    if ( ! fh )
        return ;

    while ( (p = fgets( buf1, BUFSIZE, fh )) )
    {
        StrDetab( (STRING)buf, (STRING)buf1, BUFSIZE );
        st_reduce_spaces( (STRING)buf );
        st_trim( (STRING)buf );
        keyword[0] = EOS ;
        if ( strlen(buf) )
        {
            if ( st_len_word( buf ) < 16L )     // keyword is max 15 chars
            {
                st_get_word( keyword, buf );    //  get keyword
                st_remove_word( buf );          //  remove keyword from string
            }
        }
        if ( strlen(keyword) )
        {
            if ( st_eq(keyword, "CPUi:") )
            {
                ST_CPY( cpuInv, buf );
            }
            else
            if ( st_eq(keyword, "CPUs:") )
            {
                ST_CPY( cpuSer, buf );
            }
            else
            if ( st_eq(keyword, "MONi:") )
            {
                ST_CPY( monInv, buf );
            }
            else
            if ( st_eq(keyword, "MONs:") )
            {
                ST_CPY( monSer, buf );
            }
            else
            if ( st_eq(keyword, "KEYi:") )
            {
                ST_CPY( kbInv, buf );
            }
            else
            if ( st_eq(keyword, "KEYs:") )
            {
                ST_CPY( kbSer, buf );
            }
            else
            if ( st_eq(keyword, "NIC:") )
            {
                ST_CPY( nicID, buf );
                if ( ! st_eq(nicID, nodeAddr) )
                {
                    if ( strlen(nicID) && strlen(nodeAddr) )
                    {
                        sprintf( buf, "NIC has changed from %s to %s", nicID, nodeAddr );
                        ErrMsg( buf );
                    }
                }
            }
            else
            if ( st_eq(keyword, "NIT:") )
            {
                ST_CPY( nicType, buf );
            }
            else
            if ( st_eq(keyword, "WSI:") )
            {
                ST_CPY( wsIdent, buf );
            }
            else
            if ( st_eq(keyword, "DEF:") )
            {
                ST_CPY( defUser, buf );
            }
        }
    }
    fclose ( fh );
}


void    write_eq_data( void )
{
    FILE        *fh ;
//  INT16       retcode, fx ;

    SetAttrib( eqSpec, -1, 0, 0, 0 );
    fl_delete( eqSpec );
    fh = fopen( eqSpec, "w" );
    if ( fh )
    {
        fprintf( fh, "CPUi=%s\n", cpuInv );
        fprintf( fh, "CPUs=%s\n", cpuSer );
        fprintf( fh, "MONi=%s\n", monInv );
        fprintf( fh, "MONs=%s\n", monSer );
        fprintf( fh, "KEYi=%s\n",  kbInv );
        fprintf( fh, "KEYs=%s\n",  kbSer );
        fprintf( fh, "NIC=%s\n", nodeAddr );
        fprintf( fh, "NIT=%s\n", nicType );
        fprintf( fh, "WSI=%s\n", wsIdent );
        fprintf( fh, "DEF=%s\n", defUser );
        fprintf( fh, "UID=%08lX\n", userID );
        fprintf( fh, "UNM=%s\n", userName );
        fprintf( fh, "SVR=%s\n", serverName );
        fprintf( fh, "\nUpdated: %s %s %s\n", TodaysDay(), TodaysDate(), TodaysTime() );
        fclose ( fh );
    }
    SetAttrib( eqSpec, 1, 1, 0, -1 );           // set to R/O and HIDDEN
}


void    write_batchfile( void )
{
    FILE        *fh ;

    fh = fopen( "c:\\$_danen_.bat", "w" );
    if ( fh )
    {
        fprintf( fh, "@echo off\n"
                     " set gd.logdate=%s %s %s\n"
                     " set gd.d=E\n"
                     " set gd.sound=OFF\n"
                     " set gd.kbd=c:\\z\\kb\n"
                     " set gd.cfg=c:\\ut\\cfg\n"
                     " set pr.p1=$e[37;44m[\n"
                     " set pr.p2=] $d $t$h$h$h   $_$e[1;37;\n"
                     " set pr.p3=m $p $e[0;37;44m $g $A\n"
                     " set temp=c:\\tmpfiles\n"
                     " set tmp=%%temp%%\n"
                     " mk /n %%temp%%\n",
                     TodaysDay(), TodaysDate(), TodaysTime() );
        if ( strlen(defUser) )
            fprintf( fh, " set gd.login.udef=%s\n", defUser );
        if ( strlen(nicType) )
            fprintf( fh, " set net.card.type=%s\n", nicType );
        if ( strlen(wsIdent) )
            fprintf( fh, " set ws.ident=%s\n", wsIdent );
        fclose ( fh );
    }
}


void    instructions( void )
{
    NewScreen();
    sn_beep();
    printf( "\n\n /W = WRITE equipment info\n"
                " /R = READ info & update network database\n"
                " /B = create BATCH file with env. vars in C:\\\n\n\n" );
    gd_exit( 1, "" );
}


void    main_exit( void )
{
    fcloseall();
    ClearEOS();
    CursOn();
}


void    main_init( int argc, char *argv[] )
{
    fs_init( FALSE, SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );
    Allow_No_Break();                           // allow no ^Break to abort
    atexit( main_exit );

    if ( argc != 2 )
        instructions();
    if ( st_eq(argv[1], "/r") )
        write_mode = FALSE ;
    else
    if ( st_eq(argv[1], "/w") )
        write_mode = TRUE ;
    else
    if ( st_eq(argv[1], "/b") )
        batch_mode = TRUE ;
    else
        instructions();

    sprintf( eqSpec, "%s\\%s", eqDir, eqFile );
    dr_mkdir( eqDir, NO );

    if ( batch_mode )
        return ;

    if ( ! nw_installed_NetWare() )
        abort_job( 9, "Not logged in to a NetWare file server!" );

    strcpy( serverName, nw_server_name( nw_get_default_connection_id() ) );
    nw_get_username( userName );
    if ( st_eq(userName,"") )
        abort_job( 9, "You must be logged in!" );

    if ( write_mode )
        if ( ! nw_is_supervisor(userName) )
            abort_job( 9, super_rights );

    GetBinderyObjectID( userName, OT_USER, &userID );
    nw_get_station_address( nodeAddr );
    strcpy( serverName, nw_server_name( nw_get_default_connection_id() ) );
}


void    update_network_with_data( void )
{
    INT32       sys_ymd ;
    INT16       d, m, y ;
    FILE        *fh ;

    dt_getsystemdate( &sys_ymd, &y, &m, &d );
    sprintf( logfile, "%s%s\\%s\\tracking.dat", SYSTEM_VOLUME, SYSTEM_DIR, TRACK_DIR );
    fh = fopen( logfile, "a+" );
    if ( fh )
    {
        fprintf( fh, "\"%s\",\"%ld\", \"%s\",\"%s\",\"%s\",\"%s\",\"%s\",\"%s\",\"%s\",\"%s\" \n",
                nodeAddr, sys_ymd, userName, nicType, cpuInv, cpuSer, monInv, monSer, kbInv, kbSer );

//      DOS version
//      shell version
//      mscdex version
//      total memory
//      total local hard disk space
//      available local hard disk space
//      number of real (non-stacked) local hard disks
//      Stacker used?
//      loaded?: mouse
//      loaded?: ANSI.SYS
//      loaded?: HIMEM.SYS
//      loaded?: APPEND
//      loaded?: ASSIGN
//      loaded?: DOSKEY
//      loaded?: SHARE

        fclose ( fh );
    }
}


void    main( int argc, char *argv[] )
{
    main_init( argc, argv );

    read_eq_data();                             // get current info

    if ( batch_mode )                           // create a batch file with env. vars
    {
        write_batchfile();
        happy_ending();
    }

    if ( write_mode )                           // create or update
    {
        write_eq_data();
        happy_ending();
    }

    update_network_with_data();

    happy_ending();
}
