//<c>   Copyright 1993-1999 by Gerry J. Danen; all rights reserved.

//<t>   Equipment Identification

#define IS_EQTRACK
#include"nss.h"
#include"gd_mouse.h"


#define EQTRACK_LAYOUT_VERSION 1                // change # with each file layout change!


static  char    buf[BUFSIZE], buf1[BUFSIZE], keyword[16] ;
static  UCHAR   serverName[SERVERNAME_SIZE]="", userName[B_USERNAME_SIZE]="", nodeAddr[13]="",
                eqDir[] = "C:\\NET\\MACHINE", eqFile[] = "Inv", eqSpec[sizeof(eqDir)+sizeof(eqFile)+5] ;
static  UCHAR   logfile[256] = "" ;
static  UCHAR   cpuSer[31]="", cpuInv[11]="", kbSer[31]="", kbInv[11]="", monSer[31]="", monInv[11]="",
                nicID[31]="", nicType[31]="", wsIdent[41]="", defUser[9]="" ;
static  BOOL    batch_mode = FALSE, write_mode = FALSE ;
static  ULONG   userID = 0 ;


#define FORM1_FIELDS    9
GD_DEF  *form1[FORM1_FIELDS] ;
GD_DEH  fhdr1 ;


#include"nss.ccc"


void    disk_space_info( UINT drvnum, ULONG *total, ULONG *free )
{
    struct diskfree_t dfinfo ;

    _dos_getdiskfree( drvnum, &dfinfo );
    *total = ((ULONG) (
              (ULONG) dfinfo.total_clusters *
              (ULONG) dfinfo.sectors_per_cluster *
              (ULONG) dfinfo.bytes_per_sector)) /
             ((ULONG) SZ_kBYTE) ;
    *free  = ((ULONG) (
              (ULONG) dfinfo.avail_clusters *
              (ULONG) dfinfo.sectors_per_cluster *
              (ULONG) dfinfo.bytes_per_sector)) /
             ((ULONG) SZ_kBYTE) ;
}


void    read_eq_data( void )
{
    FILE        *fh ;
    UCHAR       *p ;

    fh = fopen( eqSpec, "r" );
    if ( ! fh )
        return ;

    while ( (p = fgets( buf1, BUFSIZE, fh )) )
    {
        StrDetab( (STRING)buf, (STRING)buf1, BUFSIZE );
        st_reduce_spaces( (STRING)buf );
        st_trim( (STRING)buf );
        keyword[0] = EOS ;
        if ( strlen(buf) )
        {
            if ( st_len_word( buf ) < 16L )     // keyword is max 15 chars
            {
                st_get_word( keyword, buf );    //  get keyword
                st_remove_word( buf );          //  remove keyword from string
            }
        }
        if ( strlen(keyword) )
        {
            if ( st_eq(keyword, "CPUinv=") )
            {
                ST_CPY( cpuInv, buf );
            }
            else
            if ( st_eq(keyword, "CPUser=") )
            {
                ST_CPY( cpuSer, buf );
            }
            else
            if ( st_eq(keyword, "MONinv=") )
            {
                ST_CPY( monInv, buf );
            }
            else
            if ( st_eq(keyword, "MONser=") )
            {
                ST_CPY( monSer, buf );
            }
            else
            if ( st_eq(keyword, "KEYinv=") )
            {
                ST_CPY( kbInv, buf );
            }
            else
            if ( st_eq(keyword, "KEYser=") )
            {
                ST_CPY( kbSer, buf );
            }
            else
            if ( st_eq(keyword, "NIC=") )
            {
                ST_CPY( nicID, buf );
                if ( ! st_eq(nicID, nodeAddr) )
                {
                    if ( strlen(nicID) && strlen(nodeAddr) )
                    {
                        sprintf( buf, "NIC has changed from %s to %s", nicID, nodeAddr );
                        ErrMsg( buf );
                    }
                }
            }
            else
            if ( st_eq(keyword, "NIT=") )
            {
                ST_CPY( nicType, buf );
            }
            else
            if ( st_eq(keyword, "WSI=") )
            {
                ST_CPY( wsIdent, buf );
            }
            else
            if ( st_eq(keyword, "DEF=") )
            {
                ST_CPY( defUser, buf );
            }
        }
    }
    fclose ( fh );
}


void    write_eq_data( void )
{
    FILE        *fh ;
    INT16       retcode, fx ;
    UINT        kRAM ;
    ULONG       kb_free, kb_total ;

    blank_screen();
    kRAM = cmos_get_base_memory() + cmos_get_extended_memory();
    disk_space_info( 3, &kb_total, &kb_free );  // C: only for now

    Format_UINT32( (UINT32) kRAM, buf1 );
    sprintf( buf, "%15s KB RAM", buf1 );
    sc_msg_at( 4, 72-strlen(buf), buf );
    Format_UINT32( (UINT32) kb_total, buf1 );
    sprintf( buf, "%15s KB on C: total", buf1 );
    sc_msg_at( 5, 80-strlen(buf), buf );
    Format_UINT32( (UINT32) kb_free , buf1 );
    sprintf( buf, "%15s KB on C: free", buf1 );
    sc_msg_at( 6, 79-strlen(buf), buf );

    sc_msg_at(  6, 25, "Inventory#  Serial#" );
    sc_msg_at( 15, 37, "[Address: %s]", nodeAddr );


//  Initialize data-entry forms

    SDF_Init_Global();
    SDF_Allocate_Init( form1, &fhdr1, (FORM1_FIELDS-1) );
    SDF_Init_Form( form1, &fhdr1, (FORM1_FIELDS-1), "Form1", get_global_program_name() );

    strcpy( form1[0]->data, cpuInv );
    strcpy( form1[1]->data, cpuSer );
    strcpy( form1[2]->data, monInv );
    strcpy( form1[3]->data, monSer );
    strcpy( form1[4]->data,  kbInv );
    strcpy( form1[5]->data,  kbSer );
    strcpy( form1[6]->data, nicType );
    strcpy( form1[7]->data, wsIdent );
    strcpy( form1[8]->data, defUser );

    fx = 0 ;
    form1[fx]->prow   = form1[fx]->drow = 8 ;
    form1[fx]->pcol   = 20 ;
    form1[fx]->dcol   = 25 ;
    form1[fx]->maxlen = 10 ;
    form1[fx]->dtype  = DTYPE_TEXT ;
    form1[fx]->at_reqd= TRUE ;
    form1[fx]->at_uppercase = TRUE ;
    strcpy( form1[fx]->prompt,   "CPU" );
    strcpy( form1[fx]->helpmsg , "Enter the inventory number for the CPU" );
    fx = 1 ;
    form1[fx]->prow   = form1[fx]->drow = 8 ;
    form1[fx]->pcol   = 37 ;
    form1[fx]->dcol   = 37 ;
    form1[fx]->maxlen = 30 ;
    form1[fx]->dtype  = DTYPE_TEXT ;
    form1[fx]->at_uppercase = TRUE ;
    strcpy( form1[fx]->helpmsg , "Enter the serial number of the CPU" );

    fx = 2 ;
    form1[fx]->prow   = form1[fx]->drow = 10 ;
    form1[fx]->pcol   = 16 ;
    form1[fx]->dcol   = 25 ;
    form1[fx]->maxlen = 10 ;
    form1[fx]->dtype  = DTYPE_TEXT ;
    form1[fx]->at_reqd= TRUE ;
    form1[fx]->at_uppercase = TRUE ;
    strcpy( form1[fx]->prompt,   "Monitor" );
    strcpy( form1[fx]->helpmsg , "Enter the inventory number for the monitor" );
    fx = 3 ;
    form1[fx]->prow   = form1[fx]->drow = 10 ;
    form1[fx]->pcol   = 37 ;
    form1[fx]->dcol   = 37 ;
    form1[fx]->maxlen = 30 ;
    form1[fx]->dtype  = DTYPE_TEXT ;
    form1[fx]->at_uppercase = TRUE ;
    strcpy( form1[fx]->helpmsg , "Enter the serial number of the monitor" );

    fx = 4 ;
    form1[fx]->prow   = form1[fx]->drow = 12 ;
    form1[fx]->pcol   = 15 ;
    form1[fx]->dcol   = 25 ;
    form1[fx]->maxlen = 10 ;
    form1[fx]->dtype  = DTYPE_TEXT ;
    form1[fx]->at_reqd= TRUE ;
    form1[fx]->at_uppercase = TRUE ;
    strcpy( form1[fx]->prompt,   "Keyboard" );
    strcpy( form1[fx]->helpmsg , "Enter the inventory number for the keyboard" );
    fx = 5 ;
    form1[fx]->prow   = form1[fx]->drow = 12 ;
    form1[fx]->pcol   = 37 ;
    form1[fx]->dcol   = 37 ;
    form1[fx]->maxlen = 30 ;
    form1[fx]->dtype  = DTYPE_TEXT ;
    form1[fx]->at_uppercase = TRUE ;
    strcpy( form1[fx]->helpmsg , "Enter the serial number of the keyboard" );

    fx = 6 ;
    form1[fx]->prow   = form1[fx]->drow = 15 ;
    form1[fx]->pcol   = 15 ;
    form1[fx]->dcol   = 25 ;
    form1[fx]->maxlen = 10 ;
    form1[fx]->dtype  = DTYPE_TEXT ;
    form1[fx]->at_uppercase = TRUE ;
    strcpy( form1[fx]->prompt,   "NIC Type" );
    strcpy( form1[fx]->helpmsg , "Enter the type of NIC in this workstation, e.g. E3010 E3010x PE2 PE3" );

    fx = 7 ;
    form1[fx]->prow   = form1[fx]->drow = 18 ;
    form1[fx]->pcol   = 15 ;
    form1[fx]->dcol   = 25 ;
    form1[fx]->maxlen = 40 ;
    form1[fx]->dtype  = DTYPE_TEXT ;
    strcpy( form1[fx]->prompt,   "WS Ident" );
    strcpy( form1[fx]->helpmsg , "Enter the workstation ID, e.g. Reception in Trade Services" );

    fx = 8 ;
    form1[fx]->prow   = form1[fx]->drow = 20 ;
    form1[fx]->pcol   = 15 ;
    form1[fx]->dcol   = 25 ;
    form1[fx]->maxlen =  8 ;
    form1[fx]->dtype  = DTYPE_TEXT ;
    form1[fx]->at_uppercase = TRUE ;
    strcpy( form1[fx]->prompt,   "Def User" );
    strcpy( form1[fx]->helpmsg , "Enter the ID of the user who normally logs in at this workstation (or blank)" );

    fhdr1.fld_from = 0 ;
    fhdr1.fld_to   = fx;
    retcode = SDF_Write_Form( form1, &fhdr1 );
    retcode = SDF_Read_Form ( form1, &fhdr1 );
    if ( retcode == ESCAPE )
        abort_job( 1, "Operation cancelled" );

    ST_CPY( cpuInv , form1[0]->data );
    ST_CPY( cpuSer , form1[1]->data );
    ST_CPY( monInv , form1[2]->data );
    ST_CPY( monSer , form1[3]->data );
    ST_CPY(  kbInv , form1[4]->data );
    ST_CPY(  kbSer , form1[5]->data );
    ST_CPY( nicType, form1[6]->data );
    ST_CPY( wsIdent, form1[7]->data );
    ST_CPY( defUser, form1[8]->data );

    SetAttrib( eqSpec, -1, 0, 0, 0 );
    fl_delete( eqSpec );
    fh = fopen( eqSpec, "w" );
    if ( fh )
    {
        fprintf( fh, "[EqTrack]\nVersion= %d\n; Updated: %s %s %s\n\n[data]\n",
                 EQTRACK_LAYOUT_VERSION, TodaysDay(), TodaysDate(), TodaysTime() );
        fprintf( fh, "CPUinv= %s\n", cpuInv );
        fprintf( fh, "CPUser= %s\n", cpuSer );
        fprintf( fh, "MONinv= %s\n", monInv );
        fprintf( fh, "MONser= %s\n", monSer );
        fprintf( fh, "KEYinv= %s\n",  kbInv );
        fprintf( fh, "KEYser= %s\n",  kbSer );
        fprintf( fh, "NIC= %s\n", nodeAddr );
        fprintf( fh, "NIT= %s\n", nicType );
        fprintf( fh, "WSI= %s\n", wsIdent );
        fprintf( fh, "DEF= %s\n", defUser );
        fprintf( fh, "UID= %08lX\n", userID );
        fprintf( fh, "UNM= %s\n", userName );
        fprintf( fh, "SVR= %s\n", serverName );
        fclose ( fh );
    }

    SetAttrib( eqSpec, 1, 1, 0, -1 );           // set to R/O and HIDDEN

    MoveCursor( vid.rows-2, 1 );
}


void    write_batchfile( void )
{
    FILE        *fh ;

    fh = fopen( "c:\\$_danen_.bat", "w" );
    if ( fh )
    {
        fprintf( fh, "@echo off\n"
                     " set gd.logdate=%s %s %s\n"
                     " set gd.d=E\n"
                     " set gd.sound=OFF\n"
                     " set gd.kbd=c:\\z\\kb\n"
                     " set gd.cfg=c:\\ut\\cfg\n"
                     " set pr.p1=$e[37;44m[\n"
                     " set pr.p2=] $d $t$h$h$h   $_$e[1;37;\n"
                     " set pr.p3=m $p $e[0;37;44m $g $A\n"
                     " set temp=c:\\tmpfiles\n"
                     " set tmp=%%temp%%\n"
                     " mk /n %%temp%%\n",
                     TodaysDay(), TodaysDate(), TodaysTime() );
        if ( strlen(defUser) )
            fprintf( fh, " set gd.login.udef=%s\n", defUser );
        if ( strlen(nicType) )
            fprintf( fh, " set net.card.type=%s\n", nicType );
        if ( strlen(wsIdent) )
            fprintf( fh, " set ws.ident=%s\n", wsIdent );
        fclose ( fh );
    }
}


void    instructions( void )
{
    NewScreen();
    sn_beep();
    printf( "\n\n /W = WRITE equipment info\n"
                " /R = READ info & update network database\n"
                " /B = create BATCH file with env. vars in C:\\\n\n\n" );
    gd_exit( 1, "" );
}


void    main_exit( void )
{
    fcloseall();
    ClearEOS();
    CursOn();
}


void    main_init( int argc, char *argv[] )
{
    fs_init( FALSE, SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );
    Allow_No_Break();                           // allow no ^Break to abort
    atexit( main_exit );

    if ( argc != 2 )
        instructions();
    if ( st_eq(argv[1], "/r") )
        write_mode = FALSE ;
    else
    if ( st_eq(argv[1], "/w") )
        write_mode = TRUE ;
    else
    if ( st_eq(argv[1], "/b") )
        batch_mode = TRUE ;
    else
        instructions();

    sprintf( eqSpec, "%s\\%s", eqDir, eqFile );
    dr_mkdir( eqDir, NO );

    if ( batch_mode )
        return ;

    if ( ! nw_installed_NetWare() )
        abort_job( 9, "Not logged in to a NetWare file server!" );

    strcpy( serverName, nw_server_name( nw_get_default_connection_id() ) );
    nw_get_username( userName );
    if ( st_eq(userName,"") )
        abort_job( 9, "You must be logged in!" );

    if ( write_mode )
        if ( ! nw_is_supervisor(userName) )
            abort_job( 9, super_rights );

    GetBinderyObjectID( userName, OT_USER, &userID );
    nw_get_station_address( nodeAddr );
    strcpy( serverName, nw_server_name( nw_get_default_connection_id() ) );
}


void    update_network_with_data( void )
{
    INT32       sys_ymd, sys_time ;
    INT16       d, m, y ;
    FILE        *fh ;
    UINT        kRAM ;
    int         MSCDEXv=0, MSCDEXmaj=0, MSCDEXmin=0 ;
    int         SHELLv=0, SHELLmaj=0, SHELLmin=0, SHELLrev=0 ;
    ULONG       kb_free, kb_total ;

    if ( nw_installed_NetWare() )
        SHELLv = nw_shell_version( &SHELLmaj, &SHELLmin, &SHELLrev );
    if ( MSCDEX_installed() )
        MSCDEXv = MSCDEX_version( &MSCDEXmaj, &MSCDEXmin );
    kRAM = cmos_get_base_memory() + cmos_get_extended_memory();

//  total local hard disk space
//  available local hard disk space
    disk_space_info( 3, &kb_total, &kb_free );  // C: only for now

    dt_getsystemdate( &sys_ymd, &y, &m, &d );
    {
        INT32 tics ;
        INT16 hh, mm, ss, tt ;
        tm_getsystemtime( &sys_time, &tics, &hh, &mm, &ss, &tt );
    }

    sprintf( logfile, "%s%s\\%s\\track.dat", SYSTEM_VOLUME, SYSTEM_DIR, TRACK_DIR );
    fh = fopen( logfile, "a+" );
    if ( fh )
    {
        fprintf( fh, "\"%d\",\"%s\",\"%ld\",\"%ld\", "
                     "\"%s\",\"%s\",\"%s\",\"%s\",\"%s\",\"%s\",\"%s\",\"%s\","
                     "\"%d.%02d\",\"%d.%02d.%d\",\"%d.%02d\","
                     "\"%u\",\"%lu\",\"%lu\","
                     "\"%d\",\"%d\","
                     "\"%s\",\"%s\",\"%s\",\"%s\",\"%s\",\"%s\",\"%s\",\"%s\""
                     "\n",
                     EQTRACK_LAYOUT_VERSION, nodeAddr, sys_ymd, sys_time,
                     userName, nicType, cpuInv, cpuSer, monInv, monSer, kbInv, kbSer,
                     _osmajor,_osminor, SHELLmaj,SHELLmin,SHELLrev, MSCDEXmaj,MSCDEXmin,
                     kRAM, kb_total, kb_free,
                     // number of real (non-stacked) local hard disks
                     // Stacker used?
                     0, 0,
                     ms_init()         ? "Y" : "N",     // loaded?: mouse
                     ISLOADED_ANSI()   ? "Y" : "N",     // loaded?: ANSI.SYS
                     ISLOADED_HIMEM()  ? "Y" : "N",     // loaded?: HIMEM.SYS
                     ISLOADED_APPEND() ? "Y" : "N",     // loaded?: APPEND
                     ISLOADED_ASSIGN() ? "Y" : "N",     // loaded?: ASSIGN
                     ISLOADED_DOSKEY() ? "Y" : "N",     // loaded?: DOSKEY
                     ISLOADED_SHARE()  ? "Y" : "N",     // loaded?: SHARE
                     ISLOADED_PRINT()  ? "Y" : "N" );   // loaded?: PRINT
        fclose ( fh );
    }
}


void    main( int argc, char *argv[] )
{
    main_init( argc, argv );

    read_eq_data();                             // get current info

    if ( batch_mode )                           // create a batch file with env. vars
    {
        write_batchfile();
        happy_ending();
    }

    if ( write_mode )                           // create or update
    {
        write_eq_data();
        happy_ending();
    }

    update_network_with_data();

    happy_ending();
}
