//<c>   Copyright 1993-1999 by Gerry J. Danen; all rights reserved.

//<t>   Show Birthdays from network security file

//      File layout:
//              - user id
//              - employee id
//              - birthdate [yyyy]mmdd
//              - phone number
//              - name to display (if first char = *, don't show)
//      BLACKSTO 00450 19511024 464-0481 Opal Blackstock


#define IS_NETBDAYS
#include"nss.h"

#define MAXFOLKS 2000
static  char    *person[MAXFOLKS+1], one_person[512] ;
static  int     person_end=0, this_person=0 ;
static  INT16   sys_day, sys_mth, sys_yr, b_day, b_mth, b_yr,
                moda1, moda2, recct=0 ;
static  INT32   sys_ymd, nextBdate, this_year, next_year, days ;
static  UCHAR   userName[48], lastChOfUname, buf[512], *pB, cryptKey[512],
                fUserID[81], fEmpID[81], fBirthdate[81], fPhone[81], fUserName[81] ;
static  STRING  announce[] =
{
        "Bake a cake",
        "Bring out the candles",
        "Check the restaurant booking",
        "Dust off the party hats",
        "Get ready",
        "Grind some coffee",
        "Put some champagne on ice",
        "Woohoo",
        "Wrap a present"
};


void    wait_time_or_key( INT16 secs )
{
    INT16       ch, going = TRUE ;
    long        time_1 ;

    ch = 0 ;
    time_1 = time(0) + (long) secs ;
    while ( going )
    {
        ch = kb_getkey_nowait();
        if ( ch != 0 )
            going = FALSE ;
        if ( (long)time(0) >= time_1 )
            going = FALSE ;
    }
}


int     qs_compare( const char **arg1, const char **arg2 )
{
    return( _stricmp( *arg1, *arg2 ) );
}


void    add_person( STRING pStr )
{
    if ( person_end < MAXFOLKS )
    {
        if ( strlen(pStr) )
        {
            person[person_end] = _strdup(pStr);
            if ( person[person_end] == NULL )
            {
                ErrMsg( "Out of memory" );
                gd_exit( BAD_EXIT, "" );
            }
            person_end += 1 ;
        }
    }
    else
    {
        printf( "\nMaximum of %d entries in the list exceeded: %s\n", (int) MAXFOLKS, pStr );
    }
}


void    main( int argc, char *argv[] )
{
    int         seconds ;
    FILE        *dat ;
    UCHAR       datafile[FS_LEN] ;
    BOOL        ynQuiet = FALSE ;

    fs_init( FALSE, SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );
    RandomSeed();

    CryptKey( cryptKey );

    st_get_env_var( "netbdays.quick", datafile, sizeof(datafile), "", YES );
    if ( datafile[0] == 'Y' )
        ynQuiet = TRUE ;

    if ( argc > 1 )
    {
        strcpy( datafile, argv[1] );
        strupr( datafile );
    }
    else
    {
        if ( fl_datafilename( datafile, argv[0], "dat" ) == ERROR )
            gd_exit( 1, "Could not find data file" );
    }

    dt_getsystemdate( &sys_ymd, &sys_yr, &sys_mth, &sys_day );
    moda1 = sys_mth*100 + sys_day ;
    this_year = sys_yr * 10000L ;
    next_year = this_year + 10000L ;
// printf( "%s: %d %ld %ld\n", datafile, moda1, this_year, next_year );

    if ( nw_installed_NetWare() )
        nw_get_username( userName );
    else
        userName[0] = EOS ;

    if ( ! (dat = fopen( datafile, "r" )) )
        gd_exit( 1, "Could not open data file" );

    while ( pB = fgets( buf, sizeof(buf), dat ) )
    {
        ST_CLR_LASTCHAR(buf);
        CryptStr( buf, buf, cryptKey );
        recct += 1 ;
        fUserID[0] = fBirthdate[0] = fUserName[0] = EOS ;
        st_trim( buf );
        st_reduce_spaces( (STRING) buf );
        if ( st_len_word(buf) < (sizeof(fUserID)-1) ) // user id
        {
            st_get_word( fUserID, buf );
            st_remove_word( buf );
        }
        if ( st_len_word(buf) < (sizeof(fEmpID)-1) ) // employee id
        {
            st_get_word( fEmpID, buf );
            st_remove_word( buf );
        }
        if ( st_len_word(buf) < (sizeof(fBirthdate)-1) ) // birthdate
        {
            st_get_word( fBirthdate, buf );
            st_remove_word( buf );
        }
        if ( st_len_word(buf) < (sizeof(fPhone)-1) ) // phone #
        {
            st_get_word( fPhone, buf );
            st_remove_word( buf );
        }
        ST_CPY( fUserName, buf );               // user name
        lastChOfUname = ST_LASTCHAR(fUserName);
        if ( lastChOfUname == 'S' ||
             lastChOfUname == 'X' ||
             lastChOfUname == 'x' )
            lastChOfUname = 's' ;

        if ( strlen(fUserID) && (strlen(fBirthdate) > 3) && strlen(fUserName) &&
            (fUserName[0] != '*') )
        {
            strcpy( buf, &fBirthdate[strlen(fBirthdate)-4] );
            moda2 = atoi(buf);
            if ( moda1 > moda2 )
                nextBdate = next_year + moda2 ;
            else
                nextBdate = this_year + moda2 ;
            if ( DateSplit( nextBdate, &b_yr, &b_mth, &b_day ) != ERROR )
            {
                if ( sys_ymd == nextBdate )
                {
                    if ( st_eq(fUserID,userName) )
                    {
                        printf( "Happy Birthday, %s\n", fUserName );
                        sn_beep(); //~~~
                    }
                    else
                    {
                        sprintf( one_person, "9999 Today is %s'%s birthday",
                                fUserName, lastChOfUname=='s' ? "" : "s" );
                        add_person( one_person );
                        sn_beep();
                    }
                }
                else
                {
                    days = DaysBetween( sys_ymd, nextBdate );
                    if ( days < 22 )            // next 3 weeks (21 days)
                    {
                        if ( st_eq(fUserID,userName) )
                        {
                            FormatDate( nextBdate, buf, 1 );
                            buf[6] = EOS ;
                            sprintf( one_person, "0000 Your birthday is coming up pretty soon, on %s if I'm not mistaken!", buf );
                            add_person( one_person );
                        }
                        else
                        {
                            if ( days == 1 )
                            {
                                sprintf( one_person, "9998 %s! %s'%s birthday is tomorrow.",
                                        announce[RandomNumber(0,7)],
                                        fUserName, lastChOfUname=='s' ? "" : "s" );
                                add_person( one_person );
                            }
                            else
                            {
                                FormatDate( nextBdate, buf, 1 );
                                buf[6] = EOS ;
                                sprintf( one_person, "%04d %s'%s birthday is coming up in %ld days, on %s", (int) (9000-days),
                                        fUserName, lastChOfUname=='s' ? "" : "s", days, buf );
                                add_person( one_person );
                            }
                        }
                    }
                }
            }
            else
            {
                buf[0] = EOS ;
            }
        }
    }
    qsort( (char *)person, (size_t)person_end, (size_t)sizeof(char *), qs_compare );

    if ( ! ynQuiet )
    {
        if ( person_end > 12 )                  // show max 12 people
            this_person = person_end - 12 ;
    }
    for ( seconds = 0 ; this_person<person_end ; this_person++ )
    {
        strcpy( one_person, person[this_person] );
        st_remove_word( one_person );
        printf( "%s\n", one_person );
        seconds += 1 ;
    }
    if ( seconds )
    {
        if ( ! ynQuiet )
        {
            seconds /= 2 ;
            if ( seconds < 3 )
                seconds = 3 ;
            wait_time_or_key( seconds );
        }
    }
    gd_exit( 0, "" );
}
