//<c>   Copyright 1993-1999 by Gerry J. Danen; all rights reserved.

//<t>   Replacement for NetWare 3.X LOGIN.EXE

//      todo:
//              - display previous login date/time

//      variables automatically set: gd.maildir -> xxxxxxxx in sys:mail
//                                   svr        -> %file_server
//                                   usr        -> %login_name
//                                   usr_init   -> %full_name
//                                   stn        -> %p_station (full)
//                                   stn8       -> %p_station (right 8)
//                                   win.home   -> Windows home directory
//                                   gd.dow     -> %nday_of_week
//                                   gd.logdate -> long login date
//
//      location of files...
//          if filename is qualified, use it
//          else look on "datapath"
//          else look in directory where .exe was loaded
//          else look in current directory

#define IS_NETLOGIN
#include"nss.h"
#include"nss_mess.h"


GD_DEF  *formDat[3] ;
GD_DEH  formHdr ;

static  UCHAR   pw_sep  = '@' ;
static  STRING  prompt1 = "Login ID" ;
static  STRING  prompt2 = "Password" ;
static  UCHAR   tempdir    []   ="c:\\system\\logger",  // priv: everyone R/W
                exepath    [256]="",
                datapath   [256]="",
                scriptfile [256]="",
                maildir    [256]="",
                tloginbat  [256]="",
                auditpwfile[256]="",
                remote_nics[256]="",
                mapins_path[FS_LEN]="" ;
static  UCHAR   lname[B_USERNAME_SIZE]="", lpass[48]="", cmd[256],
                serverName[SERVERNAME_SIZE]="", userName[B_USERNAME_SIZE],
                userFullname[128]="", loginDrive='F', remote_notify_group[128] ;
static  WORD    serverID, oldConnectionID ;
static  ULONG   userID ;
FILE    *tlbat ;
static  INT32   sys_ymd, sys_ymdn ;
static  int     nday_of_week, mapins_num = 1 ;
static  BOOL    log_password=FALSE, pw_has_expired=FALSE, bulletins=FALSE,
                ynRemote=FALSE, ynRemoteReport=FALSE ;
// static login_control_t lt_old ;


#include"nss.ccc"
#include"netlrini.ccc"


BOOL    attempt_login(STRING nm,STRING pw,BOOL special);


void    output_password( int reason, STRING pw )
{
#if IS_USED_INTERNAL_ONLY
    switch ( reason )
    {
        case NO_SUCH_OBJECT                :
        case NO_SUCH_OBJECT_OR_BAD_PASSWORD:
        case 0xF0                          :
            return ;
    }
#endif
    strcpy( pw, "*" );
}


void    display_error_code( int code )
{
    DspMessage( 4,vid.cols-4, vid.normal_fg, vid.normal_bg, "%3d", code );
}


STRING  translate_code_to_msg( int code )
{
    static UCHAR m[25] ;
    int x ;

    LOOP( x, 0, (max_messages-1), 1 )
    {
        if ( code == netware_message[x].msgCode )
            return( netware_message[x].msgText );
    }
    sprintf( m, "Unknown message %04Xh", code );
    return ( m );
}


void    nw_msg_to_console( STRING msg, ... )
{
    UCHAR       nwbuf[161] ;
    va_list     arg_ptr ;

    va_start( arg_ptr, msg );
    vsprintf( nwbuf, msg, arg_ptr );
    va_end( arg_ptr );
    BroadcastToConsole( nwbuf );                // max 60 chars
}


void    log_major_problem( BOOL abort, int code, STRING msg, ... )
{
    UCHAR       mbuf[161], m_user[B_USERNAME_SIZE] ;
    va_list     arg_ptr ;
    FILE        *fh ;

    ST_CPY( m_user, userName );                 // save for later
    va_start( arg_ptr, msg );
    vsprintf( mbuf, msg, arg_ptr );
    va_end( arg_ptr );
    if ( attempt_login( bigbrother_id, bigbrother_pw, YES ) )
    {
        sprintf( cmd, "%s\\problems.dat", tempdir );
        fh = fopen( cmd, "a+" );
        if ( fh )
        {
            int skippy ;
            sprintf( cmd, "%s %8s %s", serverName, m_user, node_addr );
            skippy = 50 - strlen(cmd);
            if ( skippy < 1 )
                 skippy = 1 ;
            fprintf( fh, "%s %s problem report\n"
                         " [1] %s %s %s %*s %s\n"
                         " [2] %s\n"
                         " [3] 0x%02X (%d) %s\n\n",
                         get_global_program_name(), pgm_vers,
                         TodaysDay(), TodaysDate(), TodaysTime(), skippy, "", cmd,
                         mbuf, code, code, translate_code_to_msg( code ) );
            fclose( fh );
        }
        else
            nw_msg_to_console( "%s: Cannot log to %s", get_global_program_name(), cmd );
    }
    else
    {
//      fprintf( stderr, "\n\aCan't log at the moment.\a\nPlease report problems to your network administrator!\a\n" );
        nw_msg_to_console( "%s: Cannot login as %s", get_global_program_name(), bigbrother_id );
    }
    nw_msg_to_console( "%s: [%s] %s %s %s", get_global_program_name(), pgm_vers, TodaysDay(), TodaysDate(), TodaysTime() );
    nw_msg_to_console( "%s: %s %s %s", get_global_program_name(), serverName, m_user, node_addr );
    nw_msg_to_console( "%s: %s", get_global_program_name(), mbuf );
    nw_msg_to_console( "%s: 0x%02X (%d) %s", get_global_program_name(), code, code, translate_code_to_msg( code ) );

// quit:
    Logout();
    if ( abort )
        gd_exit( GD_ERROR_NW_NOT_LOGGED_IN, "" );
}


void    pr_centered( int l, STRING m )
{
    DspMsg( l, CenterMsg(m), vid.normal_fg, vid.normal_bg, m, YES );
}


void    show_bulletins( void )
{
    BOOL        is_net_drive ;
    INT16       drive, bull_drv=-1, mail_drv=-1 ;
    UCHAR       drv, mailbull_file[32], bullspec[9] ;
    int         fh ;
    unsigned    lread_date, lread_time, lr_date, lr_time, un ;
    struct _find_t bul ;

    LOOP( drive, 4, 26, 1 )
    {
        is_net_drive = dr_is_networked( (UCHAR) drive );
        if ( is_net_drive && dr_is_cdrom( (UCHAR) drive ) )
            is_net_drive = FALSE ;
        if ( is_net_drive && ! ValidDrive( drive-1 ) )
        {
            if ( bull_drv < 0 )
                bull_drv = drive ;
        }
    }
    if ( bull_drv < 0 )
    {
        ErrMsg( "No free drives to map to bulletin directory" );
        return ;
    }
    drv = bull_drv + '@' ;
    if ( nw_map_fakeroot( drv, "sys:public\\bulletin" ) )
    {
        ErrMsg( "Bulletin directory does not exist" );
        return ;
    }
    sprintf( mailbull_file, "sys:mail\\%lX\\lastread.bul ", userID );
    if ( _dos_open( mailbull_file, _O_RDONLY, &fh ) != 0 )  // not found
    {
        lread_date = lread_time = 0 ;
    }
    else
    {
        _dos_getftime( fh, &lread_date, &lread_time );
        _dos_close( fh );
    }

    lr_date = lread_date ;
    lr_time = lread_time ;
    sprintf( bullspec, "%c:*.bul", drv );
    if ( _dos_findfirst( bullspec, _A_NORMAL, &bul ) == 0 )
    {
        do  {
            if ((bul.wr_date > lread_date) ||
                (bul.wr_date == lread_date && bul.wr_time > lread_time) )
            {
                sprintf( cmd, "%c:%s", drv, bul.name );
                sc_save_video_state();
                fl_view_init( sc_vid_rows()-2, sc_vid_cols()/2+1, 0, "Bulletin", TRUE );
                fl_view_a_file( cmd, NO );
                fl_view_exit();
                sc_restore_video_state();
                if ((bul.wr_date > lr_date) ||
                    (bul.wr_date == lr_date && bul.wr_time > lr_time) )
                    lr_date = bul.wr_date ;
                    lr_time = bul.wr_time ;
            }
        }   while( _dos_findnext( &bul ) == 0 );
    }
    fl_delete ( mailbull_file );
    _dos_creat( mailbull_file, _A_NORMAL, &fh );
    _dos_write( fh, "?", 1, &un );
    _dos_setftime( fh, lr_date, lr_time );
    _dos_close( fh );

    nw_del_drive_mapping( drv );                // don't need this mapping anymore
}


void    preprocess_script( void )
{
    FILE        *fh ;
    char        *p, buf[sizeof(cmd)], keyword[16] ;

    ST_CPY( tloginbat, nss.fiBatchfile );

    fh = fopen( scriptfile, "r" );
    if ( ! fh )
    {
        ErrMsg( "Can't read script file %s", scriptfile );
        return ;
    }

    while ( (p = fgets( cmd, sizeof(cmd)-1, fh )) )
    {
        StrDetab( (STRING)buf, (STRING)cmd, sizeof(cmd) );
        st_reduce_spaces( (STRING)buf );
        st_trim( (STRING)buf );
        keyword[0] = EOS ;
        if ( st_len_word( buf ) < 16L )         // keyword is max 15 chars
        {
            st_get_word( keyword, buf );        // get keyword
            st_remove_word( buf );              // remove keyword from string
        }
        if ( st_eq(keyword, "mapinsert") )
        {
            if ( st_len_word( buf ) < 16L )     // keyword is max 15 chars
            {
                st_get_word( keyword, buf );    // get keyword
                st_remove_word( buf );          // remove keyword from string
                mapins_num = atoi( keyword );
                ST_CPY ( mapins_path, buf );
                st_trim( mapins_path );
                strupr ( mapins_path );
            }
        }
        else
        if ( st_eq(keyword, "logger") )
        {
            if ( st_len_word( buf ) < 16L )     // keyword is max 15 chars
            {
                st_get_word( keyword, buf );    // get keyword
                if ( st_eq(keyword, "on") )
                    log_password = TRUE ;
            }
        }
        else
        if ( st_eq(keyword, "passverify") )
        {
            ST_CPY ( auditpwfile, buf );
            st_trim( auditpwfile );
            strupr ( auditpwfile );
        }
        else
        if ( st_eq(keyword, "remote") )
        {
            ST_CPY ( remote_notify_group, buf );
            st_trim( remote_notify_group );
            ynRemoteReport = TRUE ;
        }
        else
        if ( st_eq(keyword, "bulletins") )
        {
            bulletins = TRUE ;
        }
    }

    fclose( fh );

    if ( st_eq(tloginbat,"%gd.maildir%") )
        sprintf( tloginbat, "sys:mail\\%lX\\t$login.bat", userID );
}


void    get_next_word( UCHAR parm[], UCHAR buffer[], int szParm )
{
    parm[0] = EOS ;
    if ( st_len_word( buffer ) > (long) szParm )
        return ;
    st_get_word( parm, buffer );                // get parm
    st_remove_word( buffer );                   // remove parm from buffer
}


void    process_script_line( UCHAR l[] )
{
    static UCHAR keyword[16], p1[49], p2[49], p3[49] ;
    BOOL        member ;

    get_next_word( keyword, l, 15 );
    if ( ! strlen(keyword) )
        return ;
    get_next_word( p1, l, 48 );                 // get p1

    if ( st_eq(keyword, "cls") )
    {
        fprintf( tlbat, " cls\n" );
    }
    else
    if ( st_eq(keyword, "map") )
    {
        get_next_word( p2, l, 48 );
        if ( p2[1] == ':' )
            nw_map_fakeroot( p2[0], p1 );
        else
            fprintf( tlbat, " map root %s=%s >nul\n", p2, p1 );
    }
    else
    if ( st_eq(keyword, "set") )
    {
        fprintf( tlbat, " set %s=%s\n", p1, l );
    }
    else
    if ( st_eq(keyword, "memberyn") )
    {
        get_next_word( p2, l, 48 );
        strupr( p2 );
        member = nw_is_user_in_group( userName, p1 );
        fprintf( tlbat, " set %s=%s\n", p2, (member ? "Y" : "N") );
    }
    else
    if ( st_eq(keyword, "memberset") )
    {
        get_next_word( p2, l, 48 );
        get_next_word( p3, l, 48 );
        strupr( p2 );
        member = nw_is_user_in_group( userName, p1 );
        if ( member )
            fprintf( tlbat, " set %s=%s\n", p2, p3 );
    }
}


void    process_script( void )
{
    FILE        *fh ;
    char        *p, buf[sizeof(cmd)] ;

    fh = fopen( scriptfile, "r" );
    if ( ! fh )
    {
        ErrMsg( "Can't read script file %s", scriptfile );
        return ;
    }
    fprintf( tlbat, "\nrem ---Script File %s---\nrem [%s %s %s]\n",
             scriptfile, nss.idScriptDate, nss.idScriptVers, nss.idPgmVers );

    while ( (p = fgets( cmd, sizeof(cmd)-1, fh )) )
    {
        StrDetab( (STRING)buf, (STRING)cmd, sizeof(cmd) );
        st_trim( (STRING)buf );
        if ( buf[0] == '@' )
        {
            buf[0] = ' ' ;
            st_trim( (STRING)buf );
            fprintf( tlbat, "%s%s\n", ((buf[0]==':' && buf[1]!=' ') ? "" : " "), buf );
        }
        else
        if ( buf[0] != ';' && buf[0] != '*' && buf[0] != EOS )
        {
            process_script_line( buf );
        }
    }
    fprintf( tlbat, "rem ---Script End---\n" );
    fclose( fh );
}


BOOL    attempt_login( STRING nm, STRING pw, BOOL special )
{
    int         verify ;

    strupr( nm );
    strupr( pw );
    strcpy( userName, nm );                     // in case we need to report it

//  attach to the file server that the user passed in
    verify = AttachToFileServer( serverName, &serverID );
    if ( (verify != 0) && (verify != ALREADY_ATTACHED_TO_SERVER) )
    {
        if ( special )
            return( FALSE );
        blank_screen();
        display_error_code( verify );
        if ( verify == ALREADY_ATTACHED_TO_SERVER )
            sprintf( cmd, "Already attached to server %s", serverName );
        else
        {
            sprintf( cmd, "Cannot locate server %s", serverName );
            pr_centered( 17, translate_code_to_msg(verify) );
        }
        pr_centered( 15, cmd );
        output_password( verify, pw );
        log_major_problem( YES, verify, "Attach failed for %s:%s", nm, pw );
    }

//  Save original connection ID and set the preferred connection ID to be
//  that of the server just attached to
    oldConnectionID = GetPreferredConnectionID();
    SetPreferredConnectionID( serverID );
    pw_has_expired = FALSE ;
    verify = LoginToFileServer( nm, OT_USER, pw );
    if ( verify == PASSWORD_HAS_EXPIRED || verify == PASSWORD_HAS_EXPIRED_NO_GRACE )
    {
        pw_has_expired = TRUE ;
        verify = 0 ;
    }
    if ( verify )
    {
        if ( special )
        {
            return( FALSE );
        }
        else
        {
            blank_screen();
            display_error_code( verify );
            sprintf( cmd, "%s:%s", serverName, nm );
            pr_centered( 13, cmd );
            pr_centered( 15, "Access to server denied" );
            pr_centered( 17, translate_code_to_msg(verify) );
            output_password( verify, pw );
            if ( strlen(nm) || strlen(pw) )
                log_major_problem( NO, verify, "Login failed for %s:%s", nm, pw );
            HoldMsg( NO, YES );
            return( FALSE );
        }
    }

//  Now that we're logged in, get the user's object ID
    GetBinderyObjectID( nm, OT_USER, &userID );
    {
    BYTE moreSeg, propFlags ;
    verify = ReadPropertyValue( nm, OT_USER, "IDENTIFICATION", 1, userFullname, &moreSeg, &propFlags );
    if ( verify )
        userFullname[0] = EOS ;
    st_trim( userFullname );
    }
    nw_get_username( userName );
    SetPreferredConnectionID( serverID );
    return( TRUE );
}


BOOL    password_in_commonfile( STRING pw )
{
    FILE        *pf ;
    char        *p ;

    if ( ! strlen(auditpwfile) )
        return( FALSE );
    pf = fopen( (const char *) auditpwfile, "r" );
    if ( pf == NULL )
        return( FALSE );

    while ( (p = fgets( cmd, sizeof(cmd)-2, pf )) )
    {
        st_trim( cmd );
        if ( st_eq(cmd, pw) )
        {
            fclose( pf );
            return( TRUE );
        }
    }
    fclose( pf );
    return( FALSE );
}


BOOL    password_character_check_failure( UCHAR pw[] )
{
    register int i ;
    int a=0, imax=strlen(pw)-1;

    LOOP( i, 0, imax, 1 )
    {
        if ( isspace(pw[i]) )
            return( TRUE );
        if ( ! isalpha(pw[i]) )
            a += 1 ;
    }
    if ( a == 0 )
        return( TRUE ); // no non-alpha chars
    return( FALSE );    // not failed
}


void    change_password( void )
{
    UCHAR       pass1[48], pass2[48] ;
    int         ccode ;
    INT16       retcode, fx ;

cp_params:
    blank_screen();
    DspMessage( 10, 3, vid.normal_fg, vid.normal_bg, "Your current password has expired.  In order to be able to login next time," );
    DspMessage( 11, 3, vid.normal_fg, vid.normal_bg, "you must specify a new one in the ENTER NEW PASSWORD field." );
    DspMessage( 13, 3, vid.normal_fg, vid.normal_bg, "Type the new password again after the RETYPE NEW PASSWORD prompt.  This is" );
    DspMessage( 14, 3, vid.normal_fg, vid.normal_bg, "a check to catch typing errors." );
    DspMessage( 16, 3, vid.normal_fg, vid.normal_bg, "Your new password should be at least %d characters long, and", lt.min_pw_length );
    DspMessage( 17, 3, vid.normal_fg, vid.normal_bg, "contain at least one non-alphabetic character." );

    SDF_Init_Form( formDat, &formHdr, 2, "Security", get_global_program_name() );
    fx = 0;                                     // first password
    formDat[fx]->prow   = formDat[fx]->drow = 5 ;
    formDat[fx]->pcol   =  5 ;
    formDat[fx]->dcol   = 26 ;
    formDat[fx]->dfgcol = formDat[fx]->dbgcol ;
    formDat[fx]->maxlen = sizeof(pass1);
    formDat[fx]->dtype  = DTYPE_TEXT ;
    formDat[fx]->data[0]= EOS ;
    formDat[fx]->at_reqd       =
    formDat[fx]->at_makebox    =
    formDat[fx]->at_security   =
    formDat[fx]->at_field_hold =
    formDat[fx]->at_flush_kb   =
    formDat[fx]->at_allow_esc  =
    formDat[fx]->at_uppercase  = TRUE ;
    strcpy( formDat[fx]->prompt , " Enter new password:" );
    strcpy( formDat[fx]->helpmsg, "Enter your new password" );

    fx += 1 ;                                   // second password
    formDat[fx]->prow   = formDat[fx]->drow = 7 ;
    formDat[fx]->pcol   =  5 ;
    formDat[fx]->dcol   = 26 ;
    formDat[fx]->dfgcol = formDat[fx]->dbgcol ;
    formDat[fx]->maxlen = sizeof(pass1);
    formDat[fx]->dtype  = DTYPE_TEXT ;
    formDat[fx]->data[0]= EOS ;
    formDat[fx]->at_reqd       =
    formDat[fx]->at_makebox    =
    formDat[fx]->at_security   =
    formDat[fx]->at_field_hold =
    formDat[fx]->at_flush_kb   =
    formDat[fx]->at_allow_esc  =
    formDat[fx]->at_uppercase  = TRUE ;
    strcpy( formDat[fx]->prompt , "Retype new password:" );
    strcpy( formDat[fx]->helpmsg, "Enter your new password again to verify you typed what you meant to type" );

    formHdr.fld_from = 0 ;
    formHdr.fld_to   = fx ;
    retcode = SDF_Write_Form( formDat, &formHdr );
    retcode = SDF_Read_Form ( formDat, &formHdr );
    if ( retcode == ESCAPE )
    {
        ErrMsg( "Cancelled" );
        goto cp_quit ;
    }
    strcpy( pass1, formDat[0]->data );
    strcpy( pass2, formDat[1]->data );

    if ( ! st_eq(pass1,pass2) )
    {
        if ( YesNo( "New password not retyped correctly.  Try again", YES, YES ) )
            goto cp_params ;
        ErrMsg( "Password not changed" );
        goto cp_quit ;
    }
    if ( strlen(pass1) < lt.min_pw_length )
    {
        sprintf( cmd, "Password must be at least %d characters long.  Try again", lt.min_pw_length );
        if ( YesNo( cmd, YES, YES ) )
            goto cp_params ;
        ErrMsg( "Password not changed" );
        goto cp_quit ;
    }
    if ( password_in_commonfile( pass1 ) )
    {
        if ( YesNo( "This password is too easy to guess.  Try again", YES, YES ) )
            goto cp_params ;
        ErrMsg( "Password not changed" );
        goto cp_quit ;
    }
    if ( password_character_check_failure( pass1 ) )
    {
        ErrMsg( "Password must contain at least one non-alphabetic and no spaces" );
        goto cp_params ;
    }

    ccode = ChangeBinderyObjectPassword( userName, OT_USER, lpass, pass1 );
    if ( ccode == 0 )
    {
        DspMessage( vid.rows-2, 3, vid.normal_bg, vid.normal_fg, " Password changed successfully.  Please remember it! " );
        HoldMsg( NO, YES );
        goto cp_quit ;
    }

    DspMessage( 19,3, vid.normal_bg, vid.normal_fg, " %s ", translate_code_to_msg( ccode ) );
    DspMessage( 21,3, vid.normal_bg, vid.normal_fg, " Password was not changed! " );
    display_error_code( ccode );
    if ( YesNo( "Would you like to try again", YES, YES ) )
        goto cp_params ;

cp_quit:
    NewScreen();
}


void    find_windows_directory( UCHAR winhome[] )
{
    UCHAR       wdir[256], test[256], wpath[256] ;

    winhome[0] = EOS ;
    ST_CPY( test, wPath );
    do  {
        st_get_word( wdir, test );              // get possible path
        st_remove_word( test );                 // remove from string
        sprintf( wpath, "%s\\%s", wdir, wProg );
        if ( fl_exist( wpath ) )
        {
            strcpy( winhome, wdir );
            test[0] = EOS ;
        }
    }   while( strlen(test) );
}


void    main_exit( void )
{
    if ( finish_off_code == BAD_EXIT )
        fprintf( stderr, "Aborting program %s", get_global_program_name() );
    kb_idle_remove();
    fcloseall();
    CursOn();
}


void    check_remote_nics( STRING fname, STRING nic )
{
    FILE        *fnic ;
    UCHAR       bufr[81], *b, node[13] ;

    ynRemote = FALSE ;
    fnic = fopen( fname, "r" );
    if ( ! fnic )
        return ;
    while ( b = fgets( bufr, sizeof(bufr), fnic ) )
    {
        node[0] = EOS ;
        st_trim( bufr );
        if ( strlen(bufr) )
        {
            if ( st_len_word( bufr ) < sizeof(node) )
            {
                st_get_word( node, bufr );      // get node
                st_remove_word( bufr );         // remove word from string
            }
            if ( st_eq(nic, node) )
                ynRemote = TRUE ;
        }
    }
    fclose( fnic );
}


//~~~
int     locate_file( STRING sTarget, STRING sFile, STRING sExt )
{
//  location of files...
//      if filename is qualified, use it
//      else look on "datapath"
//      else look in directory where .exe was loaded

    sprintf( sTarget, "%s%s", sFile, sExt );
    if ( fl_exist( sTarget ) )
        return( OK );
    sprintf( sTarget, "%s\\%s%s", datapath, sFile, sExt );
    if ( fl_exist( sTarget ) )
        return( OK );
    sprintf( sTarget, "%s\\%s%s", exepath, sFile, sExt );
    if ( fl_exist( sTarget ) )
        return( OK );
    log_major_problem( YES, 0xFF, "Could not locate %s%s", sFile, sExt );
    return( ERROR );
}


void    main( int argc, char *argv[] )
{
    unsigned    numofdrives ;
    int         ccode, bottom_offset=0 ;
    INT32       ymd, date_diff ;
    ULONG       oID ;
    UCHAR       *ptr ;
    BOOL        good_login, user_infocheck ;
    extern UCHAR *blank_message ;
    INT16       retcode, fx ;

    fs_init( FALSE, SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );
    Allow_No_Break();                           // allow no ^Break to abort
    atexit( main_exit );
    blank_screen();
    StatusMsg( "Initializing" );
    read_login_set();                           // get "big brother" info
    {
    INT16       d, m, y ;
    dt_getsystemdate( &sys_ymd, &y, &m, &d );
    sys_ymdn = Date2Num( sys_ymd );
    nday_of_week = dt_dow( d, m, y );
    }
    RandomSeed();                               // re-seed random number generator
                                                // used by sayings, screen blanker
    if ( ! nw_installed_NetWare() )
        abort_job( 1, "Not logged in to a NetWare file server!" );

    ST_CPY( exepath, argv[0] );                 // location of .exe file
    ptr = strrchr( exepath, '\\' );
    *ptr = EOS ;

    locate_file( iniFile    , "netlogin", ".ini" );
    load_nss_ini();
    locate_file( scriptfile , "netlogin", ".scr" );
    locate_file( remote_nics, "netlogin", ".rnc" );

    SDF_Init_Global();                          // initialize forms
    SDF_Init_Form( formDat, &formHdr, 2, "Security", get_global_program_name() );

    GetFileServerName( (WORD) 0, serverName );
    nw_get_station_address( node_addr );

    check_remote_nics( remote_nics, node_addr );
    if ( ynRemote )
        strcat( pgm_title, " [remote]" );

    loginDrive= *argv[0] ;                      // from location of .exe file
    *tempdir  = loginDrive ;
    _dos_setdrive( loginDrive - (int)'@', &numofdrives );

    nw_get_username( userName );
    if ( strlen(userName) )
    {
        ErrMsg( "Already logged in as %s.  Logging out first!", userName );
        Logout();
    }
    st_get_env_var( "GD.LOGIN.UDEF", lname, sizeof(lname), "", YES );

    preprocess_script();
    if ( nss.usKBclear )                        // do we flush keystrokes?
        FlushKeyboard();

accept_parameters:
    blank_screen();
    CursOn();
    kb_idle_reset( 60 );                        // blank after 1 minute
    kb_idle_install( kb_idle_time_n_blank );
    blank_message = "Screen Saver is Active" ;

    if ( ! ynRemote )                           // show some general info
    {
        sprintf( cmd, "Primary Server is %s", nss.glPrimaryServer );
        pr_centered( 12, nss.glOrgName );
        pr_centered( 13, nss.glSupDept );
        pr_centered( 14, cmd           );
        pr_centered( 16, nss.glSupCont );
        blank_message = nss.glSupCont ;
        sprintf( cmd, "(Troubleshooting Info: %s %s %s)",
                 nss.idScriptDate, nss.idScriptVers, nss.idPgmVers );
        pr_centered( vid.rows-2, cmd );
    }

    SDF_Init_Form( formDat, &formHdr, 2, "Login", get_global_program_name() );
    fx = 0;                                     // user id
    formDat[fx]->prow   = formDat[fx]->drow = 4 ;
    formDat[fx]->pcol   =  2 ;
    formDat[fx]->dcol   = 12 ;
    formDat[fx]->maxlen = sizeof(lname);
    formDat[fx]->dtype  = DTYPE_TEXT ;
    formDat[fx]->at_reqd       =
    formDat[fx]->at_field_hold =
    formDat[fx]->at_allow_esc  =
    formDat[fx]->at_uppercase  = TRUE ;
    strcpy( formDat[fx]->data   , lname );
    strcpy( formDat[fx]->prompt , "Login ID:" );
    strcpy( formDat[fx]->helpmsg, "Enter your user ID" );

    fx += 1 ;                                   // password
    formDat[fx]->prow   = formDat[fx]->drow = 5 ;
    formDat[fx]->pcol   =  2 ;
    formDat[fx]->dcol   = 12 ;
    formDat[fx]->dfgcol = formDat[fx]->dbgcol ;
    formDat[fx]->maxlen = sizeof(lpass);
    formDat[fx]->dtype  = DTYPE_TEXT ;
    formDat[fx]->data[0]= EOS ;
    formDat[fx]->at_reqd       =
    formDat[fx]->at_security   =
    formDat[fx]->at_field_hold =
    formDat[fx]->at_allow_esc  =
    formDat[fx]->at_uppercase  = TRUE ;
    strcpy( formDat[fx]->prompt , "Password:" );
    strcpy( formDat[fx]->helpmsg, "Enter your password" );

    formHdr.fld_from = 0 ;
    formHdr.fld_to   = fx ;
    retcode = SDF_Write_Form( formDat, &formHdr );
    retcode = SDF_Read_Form ( formDat, &formHdr );
    if ( retcode == ESCAPE )
        gd_exit( GD_ERROR_NW_NOT_LOGGED_IN, "Cancelled" );

    strcpy( lname, formDat[0]->data );
    strcpy( lpass, formDat[1]->data );

    kb_idle_remove();

    good_login = attempt_login( lname, lpass, NO );
    if ( ! good_login )
    {
        if ( YesNo( "Try again", YES, YES ) )
            goto accept_parameters ;
        else
            gd_exit( GD_ERROR_NW_NOT_LOGGED_IN, "" );
    }

//  login was successful, now the fun begins...
    sprintf( pgm_title, "Logged in %s:%s on node %s", serverName, userName, node_addr );

    if ( RandomNumber( 700, 800 ) == 777 )
        user_infocheck = TRUE ;
    else
        user_infocheck = FALSE ;

    if ( ynRemote )                             // special security for remote users
    {
        strcat( pgm_title, " [remote]" );
        if ( ynRemoteReport )   // if set up to report remote logins, then do so now
        {
            int count = 0 ;
            sprintf( cmd, "Remote user %s logged in", lname );
            count = nw_send_msg_to_group( remote_notify_group, cmd );
            sprintf( cmd, "<<REMOTE>> %d station%s notified", count, count==1 ? "" : "s" );
            nw_logmsg( cmd );
        }
        user_infocheck = TRUE ;
    }

    if ( user_infocheck )
    {
        // ask for home phone number, or birthdate (choose one at random)
        // if the answer is not correct, then ask for the other piece of info
        // at least the birthdate must be correct.  if the phone # given is
        // different, flag that to the problem file



    }

    NewScreen();
    if ( ynRemote )
        StatusMsg( "Fast login for remote users" );

#if NORTHLANDS
    bottom_offset = 1 ;
    pr_centered( vid.rows-1, "Site License granted to Northlands Park" );
#endif
    pr_centered( vid.rows-1-bottom_offset, pgm_copyrite );
    MoveCursor( 5,1 );

    ccode = get_login_control( userName, OT_USER, &oID, propValue, &lt );
    cmd[0] = EOS ;
    ymd = 21990115L ;
    if ( ccode )
    {
        strcpy( cmd, "COULD NOT ACCESS YOUR LOGIN DATA ... DID YOUR PASSWORD EXPIRE?" );
        pw_has_expired = FALSE ;                // don't allow pw change if login data not available
    }
    else
    {
        ymd = nw_bindery_date_to_ymd( &lt.pw_expires );
        date_diff = DaysBetween( sys_ymd, ymd );
        if ( pw_has_expired )
        {
            if ( ymd == 19850101 )
                sprintf( cmd, "Your password has expired.  Please change it ASAP." );
            else
                sprintf( cmd, "Your password has expired %ld day%s ago.  Please change it ASAP.", date_diff, (date_diff==1 ? "" : "s") );
        }
        else
        if ( lt.min_pw_length == 0 &&
             lt.days_betw_pw_changes.n == 0 &&
             (lt.pw_expires.y==0 && lt.pw_expires.m==0 && lt.pw_expires.d==0) &&
             (lt.grace_allowed == 0xFF && lt.grace_left == 0xFF) )
        {
            // no password required
        }
        else
        {
            if ( ymd == sys_ymd )
                strcpy( cmd, "Your password expires today!" );
            else
            if ( nss.usPWexpireNotify )
                if ( date_diff <= nss.usPWexpireNotify )
                    sprintf( cmd, "Please note: your password will expire in %ld day%s.", date_diff, (date_diff==1 ? "" : "s") );
        }
    }
    if ( strlen(cmd) )
    {
        pr_centered( 5, cmd );
        sn_beep();
        if ( pw_has_expired && lt.grace_left != 0xFF && lt.grace_left != 0 )
        {
            sprintf( cmd, "You have %d grace logins left.", lt.grace_left );
            pr_centered( 6, cmd );
        }
        if ( pw_has_expired )
        {
            if ( YesNo( "Change your password now", YES, YES ) )
                change_password();
        }
        else
        {
            DelayKbd( 15, NO, 0 );
        }
    }
    else
    {
//      char    buf[BUFSIZE] ;
//      nw_formatted_bindery_date( &lt_old.last_login, buf );
//      if ( ! (st_eq(buf, "-") && lt_old.last_login_time[0] == 0 && lt_old.last_login_time[1] == 0 && lt_old.last_login_time[2] == 0) )
//      {
//          sprintf( cmd, "Previous login on %s @ %02d:%02d:%02d", buf, lt_old.last_login_time[0], lt_old.last_login_time[1], lt_old.last_login_time[2] );
//          pr_centered( 4, cmd );
//      }
    }
    MoveCursor( 8, 1 );

    if ( strlen(nss.sayName) )                  // display saying (cookie)
    {
        if ( ! ynRemote )                       // don't waste time of remote users
        {
            sprintf( cmd, "%s%s", nss.sayMap, nss.sayName );
            nw_map_fakeroot( cmd[0], nss.sayPath );
            system( cmd );
            nw_del_drive_mapping( cmd[0] );
        }
    }

    if ( st_eq(userName,"supervisor") )
        strcpy( lname, "SUPERV" );
    else
        lname[8] = EOS ;

//~~~
//  try to create directory first, in which to write `tloginbat'
//~~~

    tlbat = fopen( tloginbat, "w" );
    if ( ! tlbat )
        abort_job( 1, "Can't create batch file %s", tloginbat );

    StrR( cmd, node_addr, 8 );
    fprintf( tlbat, "@echo off\n"
                    " set gd.logdate=%s %s %s\n"
                    " set gd.maildir=%lX\n"
                    " set svr=%s\n"
                    " set usr=%s\n"
                    " set usr_init=%s\n"
                    " set stn=%s\n"
                    " set stn8=%s\n"
                    " set stn.remote=%s\n",
                    TodaysDay(), TodaysDate(), TodaysTime(),
                    userID, serverName, lname, userFullname,
                    node_addr, cmd, (ynRemote ? node_addr : "") );

    find_windows_directory( cmd );
    fprintf( tlbat, " set win.home=%s\n", cmd );
    fprintf( tlbat, " set gd.dow=%d\n", nday_of_week );

    st_get_env_var( mapins_path, cmd, sizeof(cmd), "c:\\dos;", YES );

    if ( strlen(cmd) )
    {
        int i ;
        fprintf( tlbat, " set path=" );
        LOOP( i, 1, mapins_num, 1 )
        {
            fprintf( tlbat, "c:\\;" );
        }
        fprintf( tlbat, "%s\n", cmd );
    }
    else
    {
        ErrMsg( "Environment variable [%s] not found", mapins_path );
    }

    process_script();

#if IS_USED_INTERNAL_ONLY
    if ( log_password )
    {
        FILE    *passout ;
        int     passlength, x, cc ;
        sprintf( maildir, "%s\\%s.log", tempdir, lname );
        passout = fopen( maildir, "a+" );
        if ( passout )
        {
            fprintf( passout, "%s %s %s %s %08lX %s ", TodaysDay(), TodaysDate(), TodaysTime(), node_addr, userID, lname );
            passlength = strlen(lpass) -1 ;
            LOOP( x, 0, passlength, 1 )
            {
                cc = lpass[x] ;
                fprintf( passout, "%c%-3d", (UCHAR) cc+20, cc );
            }
            fprintf( passout, "\n" );
            fclose( passout );
        }
    }
#endif

    fclose( tlbat );

    if ( bulletins )
        show_bulletins();

    ClearEOS();

    happy_ending();
}
