//<c>   Copyright 1993-1999 by Gerry J. Danen; all rights reserved.

//<t>   Security Setup Utility

#define IS_NETSETUP
#include"nss.h"


static  UCHAR   lname[B_USERNAME_SIZE]="", lpass[48]="", lpas2[48]="", cmd[256],
                serverName[SERVERNAME_SIZE]="", userName[B_USERNAME_SIZE],
                userFullname[128]="", loginDrive='F' ;
static  WORD    serverID, oldConnectionID ;
static  ULONG   userID ;


#include"nss.ccc"


void    response( int r, int c, STRING dest, int szDest, BOOL echo )
{
    INT16 fg=vid.normal_fg, bg=vid.normal_bg ;

    if ( ! echo )
        fg = bg = vid.normal_fg ;
    wn_GetLine( DISPLAY_AND_ENTER, r,c, fg,bg, szDest, YES, dest, "" );
    if ( ! echo )
        sc_scroll( 1, DEFAULT_ATTR, r,c, r,c+szDest, SCROLL_UP );
    st_trim( dest );
    strupr ( dest );
}


void    dumpit( void )
{
    read_login_set();
    DspMessage( 4,3, vid.normal_fg, vid.normal_bg, "%s", bigbrother_id );
    DspMessage( 5,3, vid.normal_fg, vid.normal_bg, "%s", bigbrother_pw );
    DspMessage( 6,3, vid.normal_fg, vid.normal_bg, "%s", wProg );
    DspMessage( 7,3, vid.normal_fg, vid.normal_bg, "%s", wPath );
    HoldMsg( NO, YES );
    blank_screen();
    MoveCursor( vid.rows-2, 2 );
    happy_ending();
}


void    main_exit( void )
{
    if ( finish_off_code == BAD_EXIT )
        fprintf( stderr, "Aborting program %s", get_global_program_name() );
    kb_idle_remove();
    fcloseall();
    CursOn();
}


void    main( int argc, char *argv[] )
{
    FILE        *fh ;

    fs_init( FALSE, SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );
    Allow_No_Break();                           // allow no ^Break to abort
    atexit( main_exit );
    blank_screen();

    if ( ! nw_installed_NetWare() )
        abort_job( 1, "Not logged in to a NetWare file server!" );

    strcpy( serverName, nw_server_name( nw_get_default_connection_id() ) );
    nw_get_username( userName );
    nw_get_station_address( node_addr );

    sprintf( pgm_title, "Security Setup [%s:%s] on node %s", serverName, userName, node_addr );
    blank_screen();

    if ( ! nw_is_supervisor(userName) )
        abort_job( 9, super_rights );

    if ( st_eq(argv[1], "d") &&
         st_eq(argv[2], "u") &&
         st_eq(argv[3], "m") &&
         st_eq(argv[4], "p") )
        dumpit();

    CursOn();
    strcpy( wProg, "WIN.COM" );
    lname[0] = wPath[0] = EOS ;
loop:
    lpass[0] = lpas2[0] = EOS ;
    DspMessage(  5, 4, vid.normal_fg, vid.normal_bg, "Sec.Officer ID:" );
    DspMessage(  6,10, vid.normal_fg, vid.normal_bg, "Password:" );
    DspMessage(  7,12, vid.normal_fg, vid.normal_bg, "Verify:" );
    DspMessage(  9, 3, vid.normal_fg, vid.normal_bg, "Windows Program:" );
    DspMessage( 10, 3, vid.normal_fg, vid.normal_bg, "Windows Path(s):" );

    response( 5, 20, lname, sizeof(lname), YES );
    response( 6, 20, lpass, sizeof(lpass), NO  );
    response( 7, 20, lpas2, sizeof(lpas2), NO  );
    response( 9, 20, wProg, sizeof(wProg), YES );
    response(10, 20, wPath, sizeof(wPath), YES );

    if ( ! st_eq(lpass, lpas2) )
    {
        ErrMsg( "Second password not the same as first one" );
        goto loop ;
    }
    if ( strlen(lpass) < 10 )
    {
        ErrMsg( "Password should be at least 10 characters long" );
        goto loop ;
    }

    CryptStr( lname, lname, crypt_id );
    CryptStr( lpass, lpass, super_rights );
    CryptStr( wProg, wProg, super_rights );
    CryptStr( wPath, wPath, super_rights );

#if 0
    DspMessage( 12,2, YELLOW,BLACK, "Nm: %s (%d)", lname, strlen(lname) );
    DspMessage( 13,2, YELLOW,BLACK, "Pw: %s (%d)", lpass, strlen(lpass) );
    CryptStr( lname, lname, crypt_id );
    CryptStr( lpass, lpass, super_rights );
    DspMessage( 15,2, RED,BLACK, "Nm: %s", lname );
    DspMessage( 16,2, RED,BLACK, "Pw: %s", lpass );
    CryptStr( lname, lname, crypt_id );
    CryptStr( lpass, lpass, super_rights );
#endif

    fh = fopen( setupFile, "wb" );
    if ( ! fh )
        abort_job( 1, "Can't create setup file %s", setupFile );
    fprintf( fh, "%c%c%c%c%c%s%s%s%s%c%c$*", (UCHAR) 26,
             (UCHAR) strlen(lpass), (UCHAR) strlen(lname),
             (UCHAR) strlen(wProg), (UCHAR) strlen(wPath),
             lname, lpass,
             wProg, wPath,
             (UCHAR) strlen(lname), (UCHAR) strlen(lpass) );
    fclose( fh );

    CryptStr( lname, lname, crypt_id );
    CryptStr( lpass, lpass, super_rights );
    read_login_set();
    if ( ! st_eq(lname, bigbrother_id) )
        ErrMsg( "UserID not encrypted properly.  Do not use LOGIN.SET." );
    if ( ! st_eq(lpass, bigbrother_pw) )
        ErrMsg( "Password not encrypted properly.  Do not use LOGIN.SET." );

#if 0
    DspMessage( 18,2, RED,BLACK, "Nm: %s", bigbrother_id );
    DspMessage( 19,2, RED,BLACK, "Pw: %s", bigbrother_pw );
#endif

    MoveCursor( vid.rows-2, 2 );
    happy_ending();
}
