//<c>   Copyright 1993-1999 by Gerry J. Danen; all rights reserved.

//<t>   Replacement for NetWare 3.11 SETPASS.EXE

#define IS_SETPASS
#include"nss.h"
#include"nss_mess.h"


static  UCHAR   auditpwfile[256]="", scriptfile[256]="sys:login/netlogin.scr" ;
static  UCHAR   lpass[48]="", cmd[256], serverName[SERVERNAME_SIZE]="", userName[B_USERNAME_SIZE] ;
static  WORD    serverID, oldConnectionID ;
static  ULONG   userID ;


#include"nss.ccc"


void    display_error_code( int code )
{
    DspMessage( 4,vid.cols-4, vid.normal_fg, vid.normal_bg, "%3d", code );
}


STRING  translate_code_to_msg( int code )
{
    static UCHAR m[25] ;
    int x ;

    LOOP( x, 0, (max_messages-1), 1 )
    {
        if ( code == netware_message[x].msgCode )
            return( netware_message[x].msgText );
    }
    sprintf( m, "Unknown message %04Xh", code );
    return ( m );
}


void    nw_msg_to_console( STRING msg, ... )
{
    UCHAR       nwbuf[161] ;
    va_list     arg_ptr ;

    va_start( arg_ptr, msg );
    vsprintf( nwbuf, msg, arg_ptr );
    va_end( arg_ptr );
    BroadcastToConsole( nwbuf );                // max 60 chars
}


void    pr_centered( int l, STRING m )
{
    DspMsg( l, CenterMsg(m), vid.normal_fg, vid.normal_bg, m, YES );
}


void    response( int r, int c, STRING dest, int szDest, BOOL echo )
{
    INT16 fg=vid.normal_fg, bg=vid.normal_bg ;

    if ( ! echo )
        fg = bg = vid.normal_fg ;
    wn_GetLine( DISPLAY_AND_ENTER, r,c, fg,bg, szDest, YES, dest, "" );
    if ( ! echo )
        sc_scroll( 1, DEFAULT_ATTR, r,c, r,c+szDest, SCROLL_UP );
    st_trim( dest );
    strupr ( dest );
}


void    read_login_script( void )
{
    FILE        *fh ;
    char        *p, buf[sizeof(cmd)], keyword[16] ;

    fh = fopen( scriptfile, "r" );
    if ( ! fh )
    {
        ErrMsg( "Can't read login script file %s", scriptfile );
        return ;
    }
    while ( (p = fgets( cmd, sizeof(cmd)-1, fh )) )
    {
        StrDetab( (STRING)buf, (STRING)cmd, sizeof(cmd) );
        st_reduce_spaces( (STRING)buf );
        st_trim( (STRING)buf );
        keyword[0] = EOS ;
        if ( st_len_word( buf ) < 16L )         // keyword is max 15 chars
        {
            st_get_word( keyword, buf );        //  get keyword
            st_remove_word( buf );              //  remove keyword from string
        }
        if ( st_eq(keyword, "passverify") )
        {
            ST_CPY ( auditpwfile, buf );
            st_trim( auditpwfile );
            strupr ( auditpwfile );
        }
    }
    fclose( fh );
}


BOOL    password_in_commonfile( STRING pw )
{
    FILE        *pf ;
    char        *p ;

    if ( ! strlen(auditpwfile) )
        return( FALSE );
    pf = fopen( (const char *) auditpwfile, "r" );
    if ( pf == NULL )
        return( FALSE );

    while ( (p = fgets( cmd, sizeof(cmd)-2, pf )) )
    {
        st_trim( cmd );
        if ( st_eq(cmd, pw) )
        {
            fclose( pf );
            return( TRUE );
        }
    }
    fclose( pf );
    return( FALSE );
}


BOOL    password_character_check_failure( UCHAR pw[] )
{
    register int i ;
    int a=0, imax=strlen(pw)-1;

    LOOP( i, 0, imax, 1 )
    {
        if ( isspace(pw[i]) )
            return( TRUE );
        if ( ! isalpha(pw[i]) )
            a += 1 ;
    }
    if ( a == 0 )
        return( TRUE ); // no non-alpha chars
    return( FALSE );    // not failed
}


BOOL    change_password( void )
{
    UCHAR       pass1[48], pass2[48] ;
    int         ccode ;

cp_params:
    blank_screen();
    DspMessage( 14, 3, vid.normal_fg, vid.normal_bg, "Specify a new password in the ENTER NEW PASSWORD field." );
    DspMessage( 16, 3, vid.normal_fg, vid.normal_bg, "Type the new password again after the RETYPE NEW PASSWORD prompt.  This is" );
    DspMessage( 17, 3, vid.normal_fg, vid.normal_bg, "a check to catch typing errors." );
    DspMessage( 19, 3, vid.normal_fg, vid.normal_bg, "Your new password should be at least %d characters long, and", lt.min_pw_length );
    DspMessage( 20, 3, vid.normal_fg, vid.normal_bg, "contain at least one non-alphabetic character." );
    DspMessage(  5, 3, vid.normal_fg, vid.normal_bg, "   Current password:" );
    DspMessage(  7, 3, vid.normal_fg, vid.normal_bg, " Enter new password:" );
    DspMessage(  8, 3, vid.normal_fg, vid.normal_bg, "Retype new password:" );

    lpass[0] = pass1[0] = pass2[0] = EOS ;
    response( 5, 24, lpass, sizeof(lpass), NO );
    response( 7, 24, pass1, sizeof(pass1), NO );
    response( 8, 24, pass2, sizeof(pass2), NO );
    if ( ! st_eq(pass1,pass2) )
    {
        if ( YesNo( "New password not retyped correctly.  Try again", YES, YES ) )
            goto cp_params ;
        ErrMsg( "Password not changed" );
        return( ERROR );
    }
    if ( strlen(pass1) < lt.min_pw_length )
    {
        sprintf( cmd, "Password must be at least %d characters long.  Try again", lt.min_pw_length );
        if ( YesNo( cmd, YES, YES ) )
            goto cp_params ;
        ErrMsg( "Password not changed" );
        return( ERROR );
    }
    if ( password_in_commonfile( pass1 ) )
    {
        if ( YesNo( "This password is too easy to guess.  Try again", YES, YES ) )
            goto cp_params ;
        ErrMsg( "Password not changed" );
        return( ERROR );
    }
    if ( password_character_check_failure( pass1 ) )
    {
        ErrMsg( "Password must contain at least one non-alphabetic and no spaces" );
        goto cp_params ;
    }

    ccode = ChangeBinderyObjectPassword( userName, OT_USER, lpass, pass1 );
    if ( ccode == 0 )
    {
        DspMessage( vid.rows-2, 3, vid.normal_bg, vid.normal_fg, " Password changed successfully.  Please remember it! " );
        return( OK );
    }

    DspMessage( 19,3, vid.normal_bg, vid.normal_fg, " %s ", translate_code_to_msg( ccode ) );
    DspMessage( 21,3, vid.normal_bg, vid.normal_fg, " Password was not changed! " );
    display_error_code( ccode );
    if ( YesNo( "Would you like to try again", YES, YES ) )
        goto cp_params ;
    return( ERROR );
}


void    main_exit( void )
{
    if ( finish_off_code == BAD_EXIT )
        fprintf( stderr, "Aborting program %s", get_global_program_name() );
    kb_idle_remove();
    fcloseall();
    CursOn();
}


void    main( int argc, char *argv[] )
{
    BOOL        ccode ;
    ULONG       oID ;
    extern UCHAR *blank_message ;

    fs_init( FALSE, SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );
    Allow_No_Break();                           // allow no ^Break to abort
    atexit( main_exit );
    blank_screen();
    RandomSeed();                               // re-seed random number generator
                                                // used by cookies, screen blanker
    if ( ! nw_installed_NetWare() )
        abort_job( 1, "Not logged in to a NetWare file server!" );

    strcpy( serverName, nw_server_name( nw_get_default_connection_id() ) );
    nw_get_username( userName );
    get_login_control( userName, OT_USER, &oID, propValue, &lt );
    read_login_script();
    sprintf( pgm_title, "Change Password for %s:%s", serverName, userName );

    CursOn();
    kb_idle_reset( 60 );                        // blank after 1 minute
    kb_idle_install( kb_idle_time_n_blank );
    blank_message = "Change Password" ;
    ccode = change_password();
    kb_idle_remove();

    if ( ccode == OK )
        DelayKbd( 15, NO, 0 );
    blank_screen();
    pr_centered( 5, pgm_copyrite );
#if NORTHLANDS
    pr_centered( 7, "Site License granted to Northlands Park" );
#endif
    MoveCursor( vid.rows-2, 2 );
    happy_ending();
}
