//<c>   Copyright 1993-1999 by Gerry J. Danen; all rights reserved.

//<t>   Screen Saver
/*
        SS is a Screen Saver that locks the keyboard.  It is NOT a TSR and
        must be loaded by typing SS.  If you're logged into a Novell 3.xx
        network, the keyboard remains locked until the login password is
        entered.  In stand-alone mode, you type a password when you start
        the program.  This password will unlock the keyboard.
*/
#define IS_SAVER
#include"nss.h"
#include<graph.h>


#define SERVERNAME_SIZE 48                      // size of server name
#define B_USERNAME_SIZE 48                      // size of user name in bindery


struct videoconfig vc ;
UCHAR   pw[48]="", pw1[48]="" ;
static  UCHAR   serverName[SERVERNAME_SIZE]="", userName[B_USERNAME_SIZE] ;
BOOL    use_NetWare_password = FALSE, black_mode = FALSE, fast_mode = TRUE, ask_pass = TRUE ;
int     saver_type = 0 ;


//      Prototypes
void    saver(void);


#pragma check_stack(off)

void    slowdown( void )
{
#define SLOW_TICS 1
    static clock_t goal ;

    goal = SLOW_TICS + clock();
    while ( goal > clock() )
        ;
#undef SLOW_TICS
}

#pragma check_stack(on)


void    line( short x1, short y1, short x2, short y2 )
{
    _moveto( x1, y1 );
    _lineto( x2, y2 );
}


void    saver( void )
{
    int screenwide, screendeep, i, istart=0, n=0, nlast=0, rupt=1 ;

    _getvideoconfig( &vc );
    _setvideomode  ( _VRES16COLOR );    // 640 x 480, 16 color
    _getvideoconfig( &vc );

    screenwide = vc.numxpixels ;
    screendeep = vc.numypixels ;
    _setcolor( vc.numcolors );
    _clearscreen( _GCLEARSCREEN );

    FOREVER
    {
        if ( ! (rupt++ % 99) )
        {
            _clearscreen( _GCLEARSCREEN );
            if ( use_NetWare_password )
                printf( "Screen Saver protected with your Novell password" );
            else
            {
                printf( "Screen Saver" );
                if ( strlen(pw) )
                    printf( " protected with password" );
            }
            tm_sleep_secs( 3 );
            _clearscreen( _GCLEARSCREEN );
        }
        istart += 1 ;
        if ( istart > 3 )
            istart = 0 ;
        while ( n == nlast )
        {
            n = RandomNumber( 0, vc.numcolors );
        }
        _setcolor( n );
        nlast = n ;
        switch ( saver_type )
        {
            case 1 :                            // clock-wise sweep
                if ( fast_mode )
                {
                    for ( i=istart ; i < screenwide ; i += 4 )
                    {
                        line( screenwide/2, screendeep/2, i, 0 );
                    }
                    for ( i=istart ; i < screendeep ; i += 4 )
                    {
                        line( screenwide/2, screendeep/2, screenwide-1, i );
                    }
                    if ( kb_Hit() )
                        goto done ;
                    for ( i=screenwide-istart ; i > 0 ; i -= 4 )
                    {
                        line( screenwide/2, screendeep/2, i, screendeep-1 );
                    }
                    for ( i=screendeep-istart ; i > 0 ; i -= 4 )
                    {
                        line( screenwide/2, screendeep/2, 0, i );
                    }
                    if ( kb_Hit() )
                        goto done ;
                }
                else                                    // slow mode
                {
                    for ( i=istart ; i < screenwide ; i += 4 )
                    {
                        line( screenwide/2, screendeep/2, i, 0 );
                        if ( kb_Hit() )
                            goto done ;
                        slowdown();
                    }
                    for ( i=istart ; i < screendeep ; i += 4 )
                    {
                        line( screenwide/2, screendeep/2, screenwide-1, i );
                        if ( kb_Hit() )
                            goto done ;
                        slowdown();
                    }
                    for ( i=screenwide-istart ; i > 0 ; i -= 4 )
                    {
                        line( screenwide/2, screendeep/2, i, screendeep-1 );
                        if ( kb_Hit() )
                            goto done ;
                        slowdown();
                    }
                    for ( i=screendeep-istart ; i > 0 ; i -= 4 )
                    {
                        line( screenwide/2, screendeep/2, 0, i );
                        if ( kb_Hit() )
                            goto done ;
                        slowdown();
                    }
                }
                break ;

            case 2 :                            // simultaneous sweep
                if ( fast_mode )
                {
                    for ( i=istart ; i < screenwide ; i += 4 )
                    {
                        line( screenwide/2, screendeep/2, i, 0 );
                        line( screenwide/2, screendeep/2, i, screendeep-1 );
                    }
                    if ( kb_Hit() )
                        goto done ;
                    for ( i=istart ; i < screendeep ; i += 4 )
                    {
                        line( screenwide/2, screendeep/2, screenwide-1, i );
                        line( screenwide/2, screendeep/2, 0, i );
                    }
                    if ( kb_Hit() )
                        goto done ;
                }
                else                                    // slow mode
                {
                    for ( i=istart ; i < screenwide ; i += 4 )
                    {
                        line( screenwide/2, screendeep/2, i, 0 );
                        line( screenwide/2, screendeep/2, i, screendeep-1 );
                        slowdown();
                        if ( kb_Hit() )
                            goto done ;
                    }
                    for ( i=istart ; i < screendeep ; i += 4 )
                    {
                        line( screenwide/2, screendeep/2, screenwide-1, i );
                        line( screenwide/2, screendeep/2, 0, i );
                        slowdown();
                        if ( kb_Hit() )
                            goto done ;
                    }
                }
                break ;

        }
    }

done:
    kb_getkey_();
    _setvideomode( _DEFAULTMODE );
    _clearscreen( _GCLEARSCREEN );
}


static  void black_screen( void )
{
    sc_save_video_state();
    set_color( COLOR_NORMAL, BLACK, BLACK );
    set_color( COLOR_BORDER, BLACK, BLACK );
    cls();
    while ( ! kb_Hit() )
        ;
    kb_getkey_();
    sc_restore_video_state();
}


static  void clrscrn( void )
{
    vid.first_scr = TRUE ;
    NewScreen();
    CursOn();
}

void    get_pw_from_kb( int r, int c, STRING prm, STRING dest, int szDest )
{
    clrscrn();
    *dest = EOS ;
    DspMessage( r, c, vid.normal_fg, vid.normal_bg, prm );
    c += (strlen(prm)+1) ;
    wn_GetLine( DISPLAY_AND_ENTER, r,c, vid.normal_bg, vid.normal_bg, szDest, YES, dest, "" );
    sc_scroll( 1, DEFAULT_ATTR, r,c, r,c+szDest, SCROLL_UP );
    st_trim( dest );
    strupr ( dest );
}


void    main( int argc, char *argv[] )
{
    BOOL        valid_password = FALSE ;
    int         cc, i ;
    STRING      pw_prompt = "Enter your Password:" ;
    STRING      nw_prompt = "Enter your Novell Password:" ;

    fs_init( FALSE, SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );
    Allow_No_Break();                           // allow no ^Break to abort

    sc_save_video_state();                      // save for later

    argc -= 1 ;
    LOOP( i, 1, argc, 1 )                       // process parameters first
    {
        if ( st_eq(argv[i], "/s") || st_eq(argv[i], "s") )
            fast_mode = FALSE ;
        else
        if ( st_eq(argv[i], "/b") || st_eq(argv[i], "b") )
            black_mode = TRUE ;
        else
        if ( st_eq(argv[i], "/n") || st_eq(argv[i], "n") ||
             st_eq(argv[i], "/nopass") || st_eq(argv[i], "nopass") )
            ask_pass = FALSE ;
        else
        {
            clrscrn();
            printf( "\n\n\tUse /S for SLOW, or /B for a BLANK screen"
                    "\n\n\t/NOPASS (or /N) will skip password protection\n\n"
                    "\n\t%s is a Screen Saver that can lock the keyboard.  It is NOT a TSR and"
                    "\n\tmust be loaded by typing %s.  If you're logged into a Novell 3.xx"
                    "\n\tnetwork, the keyboard remains locked until the Novell password is"
                    "\n\tentered.  In stand-alone mode, you type a password when you start"
                    "\n\tthe program.  This password will unlock the keyboard.\n\n",
                    get_global_program_name(), get_global_program_name() );
            gd_exit( 1, "" );
        }
    }

//  if NetWare installed, and user logged in, use NetWare password

    if ( nw_installed_NetWare() )
    {
        nw_get_username( userName );
        if ( strlen(userName) )
            use_NetWare_password = TRUE ;
    }
    if ( ask_pass )
        if ( ! use_NetWare_password )
            get_pw_from_kb( 5, 3, pw_prompt, pw, sizeof(pw) );

    RandomSeed();
    saver_type = RandomNumber( 1, 2 );

    while ( ! valid_password )
    {
        CursOff();
        if ( black_mode )
            black_screen();
        else
            saver();
        if ( ask_pass )
        {
            if ( use_NetWare_password )
            {
                get_pw_from_kb( 5, 3, nw_prompt, pw1, sizeof(pw1) );
                cc = VerifyBinderyObjectPassword( userName, OT_USER, pw1 );
                if ( cc == 0 )
                    valid_password = TRUE ;
                else
                    ErrMsg( "Wrong password (Flagged for Intruder Lockout!)" );
            }
            else
            {
                if ( strlen(pw) )
                {
                    get_pw_from_kb( 5, 3, pw_prompt, pw1, sizeof(pw1) );
                    if ( st_eq(pw, pw1) )
                        valid_password = TRUE ;
                }
                else
                    valid_password = TRUE ;
            }
            if ( ! valid_password )
                sn_beep();
        }
        else
        {
            valid_password = TRUE ;
        }
    }

    clrscrn();
    st_shareware( "$15.00" );
    if ( SHAREWARE_VERSION )
        DelayKbd( 15, NO, 0 );
    sc_restore_video_state();

    gd_exit( 0, "" );
}
